program tran;

{$mode objfpc}{$H+}
{$APPTYPE CONSOLE}

//Compiled in Lazarus 1.6.0+FPC 3.0.0

uses
  SysUtils, LazUTF8;

type

 //Trackers structure
 PModTypes = ^ModTypes;
 ModTypes = packed record
 case Integer of
 0: (Index:array[0..65536] of byte);
 1: (ST_Delay:byte;
     ST_PositionsPointer,ST_OrnamentsPointer,ST_PatternsPointer:word;
     ST_Name:array[0..17]of char;
     ST_Size:word);
 2: (ASC1_Delay,ASC1_LoopingPosition:byte;
     ASC1_PatternsPointers,ASC1_SamplesPointers,ASC1_OrnamentsPointers:word;
     ASC1_Number_Of_Positions:byte;
     ASC1_Positions:array[0..65535-9]of byte);
 3: (ASC0_Delay:byte;
     ASC0_PatternsPointers,ASC0_SamplesPointers,ASC0_OrnamentsPointers:word;
     ASC0_Number_Of_Positions:byte;
     ASC0_Positions:array[0..65535-8]of byte);
 4: (STP_Delay:byte;
     STP_PositionsPointer,STP_PatternsPointer,
     STP_OrnamentsPointer,STP_SamplesPointer:word;
     STP_Init_Id:byte);
 5: (PT2_Delay:byte;
     PT2_NumberOfPositions:byte;
     PT2_LoopPosition:byte;
     PT2_SamplesPointers:array[0..31]of word;
     PT2_OrnamentsPointers:array[0..15]of word;
     PT2_PatternsPointer:word;
     PT2_MusicName:array[0..29]of char;
     PT2_PositionList:array[0..65535 - 131]of byte);
 6: (PT3_MusicName:array[0..$62]of char;
     PT3_TonTableId:byte;
     PT3_Delay:byte;
     PT3_NumberOfPositions:byte;
     PT3_LoopPosition:byte;
     PT3_PatternsPointer:word;
     PT3_SamplesPointers:array[0..31]of word;
     PT3_OrnamentsPointers:array[0..15]of word;
     PT3_PositionList:array[0..65535-201]of byte);
 7: (PSC_MusicName:array[0..68]of char;
     PSC_UnknownPointer:word;
     PSC_PatternsPointer:word;
     PSC_Delay:byte;
     PSC_OrnamentsPointer:word;
     PSC_SamplesPointers:array[0..31]of word);
 8: (FTC_MusicName:array[0..68]of char;
     FTC_Delay:byte;
     FTC_Loop_Position:byte;
     FTC_Slack:integer;
     FTC_PatternsPointer:word;
     FTC_Slack2:array[0..4]of byte;
     FTC_SamplesPointers:array[0..31]of word;
     FTC_OrnamentsPointers:array[0..32]of word;
     FTC_Positions:array[0..(65536 - $d4) div 2 - 1] of packed record
                                             Pattern:byte;
                                             Transposition:shortint;
                                             end);
 9: (PT1_Delay:byte;
     PT1_NumberOfPositions:byte;
     PT1_LoopPosition:byte;
     PT1_SamplesPointers:array[0..15]of word;
     PT1_OrnamentsPointers:array[0..15]of word;
     PT1_PatternsPointer:word;
     PT1_MusicName:array[0..29]of char;
     PT1_PositionList:array[0..65535-99]of byte);
 10:(FLS_PositionsPointer:word;
     FLS_OrnamentsPointer:word;
     FLS_SamplesPointer:word;
     FLS_PatternsPointers:array[1..(65536-6)div 6] of packed record
      PatternA,PatternB,PatternC:word;
     end);
 11:(SQT_Size,SQT_SamplesPointer,SQT_OrnamentsPointer,SQT_PatternsPointer,
     SQT_PositionsPointer,SQT_LoopPointer:word);
 12:(GTR_Delay:byte;
     GTR_ID:array[0..3] of char;
     GTR_Address:word;
     GTR_Name:array[0..31] of char;
     GTR_SamplesPointers:array[0..14]of word;
     GTR_OrnamentsPointers:array[0..15]of word;
     GTR_PatternsPointers:array[0..31] of packed record
      PatternA,PatternB,PatternC:word;
     end;
     GTR_NumberOfPositions:byte;
     GTR_LoopPosition:byte;
     GTR_Positions:array[0..65536 - 295 - 1]of byte);
{ 13:(PSM_PositionsPointer:word;
     PSM_SamplesPointer:word;
     PSM_OrnamentsPointer:word;
     PSM_PatternsPointer:word;
     PSM_Remark:array[0..65535-8]of byte);}
 end;

 //Supported types
  Available_Types =
  ({Unknown, OUTFile, ZXAYFile, EPSGFile, AYFile, AYMFile, }STCFile, ASCFile,
   {ASC0File, }STPFile, PSCFile, FLSFile, FTCFile, PT1File, PT2File, PT3File,
   SQTFile, GTRFile{, FXMFile, PSMFile, VTXFile, YM2File, YM3File, YM3BFile,
   YM5File, YM6File, PSGFile, MP3File, MP2File, MP1File, OGGFile, WAVFile,
   AIFFile, APEFile, FLACFile, WVFile, AC3File, WMAFile, MO3File, ITFile, XMFile, S3MFile,
   MTMFile, MODFile, UMXFile, CDAFile, MIDFile, RMIFile, KARFile, XMIFile});

const
 TrkFileMin = STCFile;
 TrkFileMax = GTRFile;//PSMFile;
 KsaId = 'KSA SOFTWARE COMPILATION OF ';

procedure RaiseBadFileStructure;
begin
raise Exception.Create('File Structure Error');
end;

procedure incr(var i:longword);
begin
inc(i);
if i >= 65536 then RaiseBadFileStructure;
end;

{procedure GetTimeGTR(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 a:byte;
 a1:shortint;
 flg:boolean;
 j1:longword;

  begin
   with Module^ do
    begin
     a := 0; a1 := 0; flg := False;
     j1 := GTR_PatternsPointers[GTR_Positions[0] div 6].PatternA;
     repeat
      Dec(a1);
      if a1 < 0 then
       begin
        a1 := 0;
        while Index[j1] = 255 do
         begin
          Inc(a);
          flg := a >= GTR_NumberOfPositions;
          if flg then break;
          if a = GTR_LoopPosition then Lp := tm;
          j1 := GTR_PatternsPointers[Module^.GTR_Positions[a] div 6].PatternA;
         end;
        if flg then break;
        repeat
         case Index[j1] of
         0..$5f:
          begin
           Incr(j1);
           if a = 0 then inc(Nt);
           break
          end;
         $D0..$DF:
          begin
           Incr(j1);
           break
          end;
         $80..$BF:
          a1 := Index[j1] - $80;
         $C0..$CF:
          Inc(j1);
         $E0:
          if GTR_ID[3] <> #$10 then
           begin
            Incr(j1);
            break
           end
         end;
         Incr(j1)
        until False
       end;
      Inc(tm,GTR_Delay)
     until False;

     j1 := GTR_PatternsPointers[GTR_Positions[0] div 6].PatternB;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        inc(Nt);
       $C0..$CF:
        Inc(j1);
       end;
       Incr(j1)
      end;

     j1 := GTR_PatternsPointers[GTR_Positions[0] div 6].PatternC;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        inc(Nt);
       $C0..$CF:
        Inc(j1);
       end;
       Incr(j1)
      end;
    end
end;

procedure GetTimeSTC(Module:PModTypes;var Tm,Nt:integer);
var
 i,j:integer;
 j1,j2:longword;
 a:byte;
begin
   with Module^ do
    begin
     j := -1;
     repeat
      inc(j);
      j2 := ST_PositionsPointer + j * 2;
      incr(j2);
      j2 := Index[j2];
      i := -1;
      repeat
       inc(i);
       j1 := ST_PatternsPointer + 7 * i;
       if j1 >= 65535 then RaiseBadFileStructure
      until Index[j1] = j2;
      j1 := WordPtr(@Index[j1 + 1])^;
      a := 1;
      while Index[j1] <> 255 do
       begin
        case Index[j1] of
        0..$5f:
         begin
          Inc(tm,a);
          if j = 0 then Inc(Nt)
         end;
        $80,$81:
         Inc(tm,a);
        $a1..$e0:
         a := Index[j1] - $a0;
        $83..$8e:
         inc(j1)
        end;
        incr(j1)
       end
     until j = Index[ST_PositionsPointer];
     tm := tm * ST_Delay;

     j2 := ST_PositionsPointer;
     incr(j2);
     j2 := Index[j2];
     i := -1;
     repeat
      inc(i);
      j1 := ST_PatternsPointer + 7 * i;
      if j1 >= 65535 then RaiseBadFileStructure
     until Index[j1] = j2;
     j2 := j1;
     j1 := WordPtr(@Index[j1 + 1 + 2])^;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        Inc(Nt);
       $83..$8e:
        inc(j1)
       end;
       incr(j1)
      end;

     j1 := WordPtr(@Index[j2 + 1 + 4])^;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        Inc(Nt);
       $83..$8e:
        inc(j1)
       end;
       incr(j1)
      end

    end
end;

procedure GetTimeASC(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 i:integer;
 j1,j2,j3:longword;
 b:byte;
 a1,a2,a3,a11,a22,a33:shortint;
 Env1,Env2,Env3:boolean;
 DLCatcher:integer;
begin
    a1 := 0; a2 := 0; a3 := 0;
    a11 := 0; a22 := 0; a33 := 0;
    Env1 := False; Env2 := False; Env3 := False;
    with Module^ do
     begin
      b := ASC1_Delay;
      DLCatcher := 16384;
      for i := 0 to ASC1_Number_Of_Positions - 1 do
       begin
        if ASC1_LoopingPosition = i then Lp := tm;
        j1 := WordPtr(@Index[ASC1_PatternsPointers + 6 * Index[i + 9]])^ +
                              ASC1_PatternsPointers;
        j2 := WordPtr(@Index[ASC1_PatternsPointers + 6 * Index[i + 9] + 2])^ +
                              ASC1_PatternsPointers;
        j3 := WordPtr(@Index[ASC1_PatternsPointers + 6 * Index[i + 9] + 4])^ +
                              ASC1_PatternsPointers;
        repeat
         dec(a1);
         if a1 < 0 then
          begin
           if Index[j1] = 255 then break;
           repeat
            case Index[j1] of
            0..$55:
             begin
              a1 := a11;
              incr(j1);
              if Env1 then incr(j1);
              if i = 0 then inc(Nt);
              break
             end;
            $56..$5f:
             begin
              a1 := a11;
              incr(j1);
              break
             end;
            $60..$9f:
             a11 := Index[j1] - $60;
            $e0:
             Env1 := True;
            $e1..$ef:
             Env1 := False;
            $f0,$f5..$f7,$f9,$fb:
             inc(j1);
            $f4:
             begin
              incr(j1);
              b := Index[j1]
             end
            end;
            incr(j1)
           until False;
          end;
         dec(a2);
         if a2 < 0 then
          repeat
           case Index[j2] of
           0..$55:
            begin
             a2 := a22;
             incr(j2);
             if Env2 then incr(j2);
             if i = 0 then inc(Nt);
             break
            end;
           $56..$5f:
            begin
             a2 := a22;
             incr(j2);
             break
            end;
           $60..$9f:
            a22 := Index[j2] - $60;
           $e0:
            Env2 := True;
           $e1..$ef:
            Env2 := False;
           $f0,$f5..$f7,$f9,$fb:
            inc(j2);
           $f4:
            begin
             incr(j2);
             b := Index[j2]
            end
           end;
           incr(j2)
          until False;
         dec(a3);
         if a3 < 0 then
          repeat
           case Module^.Index[j3] of
           0..$55:
            begin
             a3 := a33;
             incr(j3);
             if Env3 then incr(j3);
             if i = 0 then inc(Nt);
             break
            end;
           $56..$5f:
            begin
             a3 := a33;
             incr(j3);
             break
            end;
           $60..$9f:
            a33 := Index[j3] - $60;
           $e0:
            env3 := True;
           $e1..$ef:
            env3 := False;
           $f0,$f5..$f7,$f9,$fb:
            inc(j3);
           $f4:
            begin
             incr(j3);
             b := Index[j3]
            end
           end;
           incr(j3)
          until False;
         Inc(tm,b);
         Dec(DLCatcher);
         if DLCatcher < 0 then RaiseBadFileStructure
        until False
       end
     end
end;

procedure GetTimeSTP(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 a:byte;
 i:integer;
 j1:longword;
begin
   a := 1;
   with Module^ do
    begin
     for i := 0 to Index[STP_PositionsPointer] - 1 do
      begin
       if i = Index[STP_PositionsPointer + 1] then
        Lp := tm * STP_Delay;
       j1 := WordPtr(@Index[STP_PatternsPointer +
                      Index[STP_PositionsPointer + 2 + i * 2]])^;
       while Index[j1] <> 0 do
        begin
         case Index[j1] of
         1..$60:
          begin
           Inc(tm,a);
           if i = 0 then inc(Nt);
          end; 
         $d0..$ef:
          Inc(tm,a);
         $80..$BF:
          a := Index[j1] - $7f;
         $c0..$cf,$f0:
          inc(j1)
         end;
         incr(j1)
        end
      end;
     tm := tm * STP_Delay;

     j1 := WordPtr(@Index[STP_PatternsPointer + 2 +
                      Index[STP_PositionsPointer + 2]])^;
     while Index[j1] <> 0 do
      begin
       case Index[j1] of
       1..$60:
        inc(Nt);
       $c0..$cf,$f0:
        inc(j1)
       end;
       incr(j1)
      end;

     j1 := WordPtr(@Index[STP_PatternsPointer + 4 +
                      Index[STP_PositionsPointer + 2]])^;
     while Index[j1] <> 0 do
      begin
       case Index[j1] of
       1..$60:
        inc(Nt);
       $c0..$cf,$f0:
        inc(j1)
       end;
       incr(j1)
      end

    end
end;

procedure GetTimePT2(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 i:integer;
 b:byte;
 a1,a2,a3,a11,a22,a33:shortint;
 DLCatcher:integer;
 j1,j2,j3:longword;
begin
   with Module^ do
    begin
     b := PT2_Delay;
     a1 := 0; a2 := 0; a3 := 0;
     a11 := 0; a22 := 0; a33 := 0;
     DLCatcher := 16384;
     i := 0;
     repeat
       if i >= 65536-131 then RaiseBadFileStructure;
       if shortint(PT2_PositionList[i]) < 0 then break;
       if i = PT2_LoopPosition then Lp := tm;
       j1 := WordPtr(@Index[PT2_PatternsPointer +
                                PT2_PositionList[i] * 6])^;
       j2 := WordPtr(@Index[PT2_PatternsPointer +
                                PT2_PositionList[i] * 6 + 2])^;
       j3 := WordPtr(@Index[PT2_PatternsPointer +
                                PT2_PositionList[i] * 6 + 4])^;
       repeat
        dec(a1);
        if a1 < 0 then
         begin
          if Index[j1] = 0 then break;
          repeat
           case Index[j1] of
           $80..$df:
            begin
             a1 := a11;
             incr(j1);
             if i = 0 then inc(Nt);
             break
            end;
           $70,$e0:
            begin
             a1 := a11;
             incr(j1);
             break
            end;
           $71..$7e:
            inc(j1,2);
           $20..$5f:
            a11 := Index[j1] - $20;
           $f:
            begin
             incr(j1);
             b := Index[j1]
            end;
           1..$b,$e:
            inc(j1);
           $d:
            inc(j1,3)
           end;
           incr(j1)
          until False
         end;
        dec(a2);
        if a2 < 0 then
         repeat
          case Index[j2] of
          $80..$df:
           begin
            a2 := a22;
            incr(j2);
            if i = 0 then inc(Nt);
            break
           end;
          $70,$e0:
           begin
            a2 := a22;
            incr(j2);
            break
           end;
          $71..$7e:
           inc(j2,2);
          $20..$5f:
           a22 := Index[j2] - $20;
          $f:
           begin
            incr(j2);
            b := Index[j2]
           end;
          1..$b,$e:
           inc(j2);
          $d:
           inc(j2,3)
          end;
          incr(j2)
         until False;
        dec(a3);
        if a3 < 0 then
         repeat
          case Index[j3] of
          $80..$df:
           begin
            a3 := a33;
            incr(j3);
            if i = 0 then inc(Nt);
            break
           end;
          $70,$e0:
           begin
            a3 := a33;
            incr(j3);
            break
           end;
          $71..$7e:
           inc(j3,2);
          $20..$5f:
           a33 := Index[j3] - $20;
          $f:
           begin
            incr(j3);
            b := Index[j3]
           end;
          1..$b,$e:
           inc(j3);
          $d:
           inc(j3,3)
          end;
          incr(j3)
         until False;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure
       until False;
       inc(i)
     until False
    end
end;

procedure GetTimePT3(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 a1,a2,a3,a11,a22,a33:shortint;
 j1,j2,j3:longword;
 i,j,DLCatcher:integer;
 c1,c2,c3,c4,c5,c8:integer;
begin
   with Module^ do
    begin
     b := PT3_Delay;
     a11 := 1; a22 := 1; a33 := 1;
     DLCatcher := 16384;
     for i := 0 to PT3_NumberOfPositions - 1 do
      begin
       if i = PT3_LoopPosition then Lp := tm;
       j1 := WordPtr(@Index[PT3_PatternsPointer +
                                PT3_PositionList[i] * 2])^;
       j2 := WordPtr(@Index[PT3_PatternsPointer +
                                PT3_PositionList[i] * 2 + 2])^;
       j3 := WordPtr(@Index[PT3_PatternsPointer +
                                PT3_PositionList[i] * 2 + 4])^;
       a1 := 1; a2 := 1; a3 := 1;
       repeat
        dec(a1);
        if a1 = 0 then
         begin
          if Index[j1] = 0 then break;
          j := 0; c1 := 0; c2 := 0; c3 := 0; c4 := 0; c5 := 0; c8 := 0;
          repeat
           case Index[j1] of
           $50..$af:
            begin
             a1 := a11;
             incr(j1);
             if i = 0 then inc(Nt);
             break
            end;
           $d0,$c0:
            begin
             a1 := a11;
             incr(j1);
             break
            end;
           $10,$f0..$ff:
            inc(j1);
           $b2..$bf:
            inc(j1,2);
           $b1:
            begin
             incr(j1);
             a11 := Index[j1]
            end;
           $11..$1f:
            inc(j1,3);
           1:
            begin
             inc(j);
             c1 := j
            end;
           2:
            begin
             inc(j);
             c2 := j
            end;
           3:
            begin
             inc(j);
             c3 := j
            end;
           4:
            begin
             inc(j);
             c4 := j
            end;
           5:
            begin
             inc(j);
             c5 := j
            end;
           8:
            begin
             inc(j);
             c8 := j
            end;
           9:
            inc(j)
           end;
           incr(j1)
          until False;
          while j > 0 do
           begin
            if (j = c1) or (j = c8) then
             inc(j1,3)
            else if (j = c2) then
             inc(j1,5)
            else if (j = c3) or (j = c4) then
             inc(j1)
            else if (j = c5) then
             inc(j1,2)
            else
             begin
              b := Index[j1];
              inc(j1)
             end;
            if j1 >= 65536 then RaiseBadFileStructure;
            dec(j)
           end
         end;
        dec(a2);
        if a2 = 0 then
         begin
          j := 0; c1 := 0; c2 := 0; c3 := 0; c4 := 0; c5 := 0; c8 := 0;
          repeat
           case Index[j2] of
           $50..$af:
            begin
             a2 := a22;
             incr(j2);
             if i = 0 then inc(Nt);
             break
            end;
           $d0,$c0:
            begin
             a2 := a22;
             incr(j2);
             break
            end;
           $10,$f0..$ff:
            inc(j2);
           $b2..$bf:
            inc(j2,2);
           $b1:
            begin
             incr(j2);
             a22 := Index[j2]
            end;
           $11..$1f:
            inc(j2,3);
           1:
            begin
             inc(j);
             c1 := j
            end;
           2:
            begin
             inc(j);
             c2 := j
            end;
           3:
            begin
             inc(j);
             c3 := j
            end;
           4:
            begin
             inc(j);
             c4 := j
            end;
           5:
            begin
             inc(j);
             c5 := j
            end;
           8:
            begin
             inc(j);
             c8 := j
            end;
           9:
            inc(j)
           end;
           incr(j2)
          until False;
          while j > 0 do
           begin
            if (j = c1) or (j = c8) then
             inc(j2,3)
            else if (j = c2) then
             inc(j2,5)
            else if (j = c3) or (j = c4) then
             inc(j2)
            else if (j = c5) then
             inc(j2,2)
            else
             begin
              b := Index[j2];
              inc(j2)
             end;
            if j2 >= 65536 then RaiseBadFileStructure;
            dec(j)
           end
         end;
        dec(a3);
        if a3 = 0 then
         begin
          j := 0; c1 := 0; c2 := 0; c3 := 0; c4 := 0; c5 := 0; c8 := 0;
          repeat
           case Module^.Index[j3] of
           $50..$af:
            begin
             a3 := a33;
             incr(j3);
             if i = 0 then inc(Nt);
             break
            end;
           $d0,$c0:
            begin
             a3 := a33;
             incr(j3);
             break
            end;
           $10,$f0..$ff:
            inc(j3);
           $b2..$bf:
            inc(j3,2);
           $b1:
            begin
             incr(j3);
             a33 := Index[j3]
            end;
           $11..$1f:
            inc(j3,3);
           1:
            begin
             inc(j);
             c1 := j
            end;
           2:
            begin
             inc(j);
             c2 := j
            end;
           3:
            begin
             inc(j);
             c3 := j
            end;
           4:
            begin
             inc(j);
             c4 := j
            end;
           5:
            begin
             inc(j);
             c5 := j
            end;
           8:
            begin
             inc(j);
             c8 := j
            end;
           9:
            inc(j)
           end;
           incr(j3)
          until False;
          while j > 0 do
           begin
            if (j = c1) or (j = c8) then
             inc(j3,3)
            else if (j = c2) then
             inc(j3,5)
            else if (j = c3) or (j = c4) then
             inc(j3)
            else if (j = c5) then
             inc(j3,2)
            else
             begin
              b := Index[j3];
              inc(j3)
             end;
            if j3 >= 65536 then RaiseBadFileStructure;
            dec(j)
           end
         end;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure
       until False
      end
    end
end;

procedure GetTimePSC(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 pptr,cptr,pptr0:longword;
 j1,j2,j3:longword;
 a1,a2,a3:shortint;
 i:integer;
begin
   with Module^ do
    begin
     b := PSC_Delay;
     pptr := PSC_PatternsPointer;
     incr(pptr);
     pptr0 := pptr + 8;
     while Index[pptr] <> 255 do
      begin
       inc(pptr,8);
       if pptr >= 65536 then RaiseBadFileStructure
      end;
     if pptr >= 65536 - 2 then RaiseBadFileStructure;
     cptr := WordPtr(@Index[pptr + 1])^;
     incr(cptr);
     pptr := PSC_PatternsPointer;
     incr(pptr);
     while Index[pptr] <> 255 do
      begin
       if pptr = cptr then Lp := tm;
       if pptr >= 65536 - 6 then RaiseBadFileStructure;
       j1 := WordPtr(@Index[pptr + 1])^;
       j2 := WordPtr(@Index[pptr + 3])^;
       j3 := WordPtr(@Index[pptr + 5])^;
       Inc(pptr,8);
       if pptr >= 65536 then RaiseBadFileStructure;
       a1 := 1; a2 := 1; a3 := 1;
       for i := 1 to Index[pptr - 8] do
        begin
         dec(a1);
         if a1 = 0 then
          repeat
           case Index[j1] of
           $c0..$ff:
            begin
             a1 := Index[j1] - $bf;
             inc(j1);
             break
            end;
           $67..$6d,$6f..$7b:
            inc(j1);
           $6e:
            begin
             incr(j1);
             b := Index[j1]
            end;
           $0..$56:
            if pptr = pptr0 then inc(Nt);
           end;
           incr(j1)
          until False;
         dec(a2);
         if a2 = 0 then
          repeat
           case Index[j2] of
           $c0..$ff:
            begin
             a2 := Index[j2] - $bf;
             inc(j2);
             break
            end;
           $67..$6d,$6f..$79,$7b:
            inc(j2);
           $6e:
            begin
             incr(j2);
             b := Index[j2]
            end;
           $7a:
            inc(j2,3);
           $0..$56:
            if pptr = pptr0 then inc(Nt);
           end;
           incr(j2)
          until False;
         dec(a3);
         if a3 = 0 then
          repeat
           case Index[j3] of
           $c0..$ff:
            begin
             a3 := Index[j3] - $bf;
             inc(j3);
             break
            end;
           $67..$6d,$6f..$7b:
            inc(j3);
           $6e:
            begin
             incr(j3);
             b := Index[j3]
            end;
           $0..$56:
            if pptr = pptr0 then inc(Nt);
           end;
           incr(j3)
          until False;
         Inc(tm,b)
        end
      end
    end
end;

procedure GetTimeFTC(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 i:integer;
 j1,j2,j3:longword;
 a1,a2,a3:shortint;
 DLCatcher:integer;
begin
   with Module^ do
    begin
     b := FTC_Delay;
     i := 0;
     repeat
      if FTC_Positions[i].Pattern = 255 then break;
      if i = FTC_Loop_Position then Lp := tm;
      j1 := WordPtr(@Index[FTC_PatternsPointer +
                           FTC_Positions[i].Pattern * 6])^;
      j2 := WordPtr(@Index[FTC_PatternsPointer +
                           FTC_Positions[i].Pattern * 6 + 2])^;
      j3 := WordPtr(@Index[FTC_PatternsPointer +
                           FTC_Positions[i].Pattern * 6 + 4])^;
      Inc(i);
      if i >= (65536 - $d4) div 2 then RaiseBadFileStructure;
      a1 := 0; a2 := 0; a3 := 0;
      DLCatcher := 256;
      repeat
       Dec(a1);
       if a1 < 0 then
        begin
         if Index[j1] = 255 then break;
         repeat
          case Index[j1] of
          $60..$cb:
           begin
            a1 := 0;
            Incr(j1);
            if i = 1 then inc(Nt);
            break
           end;
          $30:
           begin
            a1 := 0;
            Incr(j1);
            break
           end;
          $40..$5f:
           begin
            a1 := Index[j1] - $40;
            Incr(j1);
            break
           end;
          $ee,$ef:
           Inc(j1);
          $31..$3e,$ed:
           Inc(j1,2);
          $f0..$ff:
           begin
            Incr(j1);
            b := Index[j1]
           end
          end;
          Incr(j1)
         until False
        end;
        Dec(a2);
        if a2 < 0 then
         repeat
          case Index[j2]of
          $60..$cb:
           begin
            a2 := 0;
            Incr(j2);
            if i = 1 then inc(Nt);
            break
           end;
          $30:
           begin
            a2 := 0;
            Incr(j2);
            break
           end;
          $40..$5f:
           begin
            a2 := Index[j2] - $40;
            Incr(j2);
            break
           end;
          $ee,$ef:
           inc(j2);
          $31..$3e,$ed:
           inc(j2,2);
          $f0..$ff:
           begin
            incr(j2);
            b := Index[j2]
           end
          end;
          Incr(j2)
         until False;
        Dec(a3);
        if a3 < 0 then
         repeat
          case Index[j3] of
          $60..$cb:
           begin
            a3 := 0;
            Incr(j3);
            if i = 1 then inc(Nt);
            break
           end;
          $30:
           begin
            a3 := 0;
            Incr(j3);
            break
           end;
          $40..$5f:
           begin
            a3 := Index[j3] - $40;
            Incr(j3);
            break
           end;
          $ee,$ef:
           inc(j3);
          $31..$3e,$ed:
           inc(j3,2);
          $f0..$ff:
           begin
            Incr(j3);
            b := Index[j3]
           end
          end;
          Incr(j3)
         until False;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure
      until False
     until False
    end
end;

procedure GetTimeSQT(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 pptr,pptr0,cptr:longword;
 f71,f72,f73,
 f61,f62,f63,
 f41,f42,f43,flg:boolean;
 j1,j2,j3:longword;
 j11,j22,j33:word;
 b:byte;
 a1,a2,a3:shortint;
 i:integer;
begin
   with Module^ do
    begin
     pptr := SQT_PositionsPointer;
     pptr0 := pptr + 7;
     while Index[pptr] <> 0 do
      begin
       if pptr = SQT_LoopPointer then Lp := tm;
       f41 := Index[pptr] and 128 <> 0;
       j1 := WordPtr(@Index[byte(Index[pptr] * 2) + SQT_PatternsPointer])^;
       Incr(j1);
       Inc(pptr,2);
       if pptr >= 65536 then RaiseBadFileStructure;
       f42 := Index[pptr] and 128 <> 0;
       j2 := WordPtr(@Index[byte(Index[pptr] * 2) + SQT_PatternsPointer])^;
       Incr(j2);
       Inc(pptr,2);
       if pptr >= 65536 then RaiseBadFileStructure;
       f43 := Index[pptr] and 128 <> 0;
       j3 := WordPtr(@Index[byte(Index[pptr] * 2) + SQT_PatternsPointer])^;
       Incr(j3);
       Inc(pptr,2);
       if pptr >= 65536 then RaiseBadFileStructure;
       b := Index[pptr];
       Incr(pptr);
       a1 := 0; a2 := 0; a3 := 0;
       for i := 1 to Index[j1 - 1] do
        begin
         if a1 <> 0 then
          begin
           dec(a1);
           if f71 then
            begin
             cptr := j11;
             f61 := False;
             if Index[cptr] in [0..$7f] then
              begin
               Incr(cptr);
               case Index[cptr] of
               0..$7f:
                begin
                 Incr(cptr);
                 if f61 then j1 := cptr + 1;
                 case Index[cptr - 1] - 1 of
                 4:
                  if f41 then
                   begin
                    b := Index[cptr] and 31;
                    if b = 0 then b := 32
                   end;
                 5:
                  if f41 then
                   begin
                    b := (b + Index[cptr]) and 31;
                    if b = 0 then b := 32
                   end
                 end
                end;
               $80..$ff:
                begin
                 if Index[cptr] and 64 <> 0 then
                  begin
                   Incr(cptr);
                   if Index[cptr] and 15 <> 0 then
                    begin
                     Incr(cptr);
                     if f61 then j1 := cptr + 1;
                     case (Index[cptr - 1]) and 15 - 1 of
                     4:
                      if f41 then
                       begin
                        b := Index[cptr] and 31;
                        if b = 0 then b := 32
                       end;
                     5:
                      if f41 then
                       begin
                        b := (b + Index[cptr]) and 31;
                        if b = 0 then b := 32
                       end
                     end
                    end
                  end
                end
               end
              end
            end
          end
         else
          begin
           if j1 >= 65536 then RaiseBadFileStructure;
           cptr := j1;
           f61 := True;
           f71 := False;
           repeat
            case Index[cptr] of
            0..$5f:
             begin
              if pptr = pptr0 then inc(Nt);
              j11 := cptr;
              Incr(cptr);
              case Index[cptr] of
              0..$7f:
               begin
                Incr(cptr);
                if f61 then
                 begin
                  j1 := cptr + 1;
                  f61 := False
                 end;
                case Index[cptr - 1] - 1 of
                4:
                 if f41 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f41 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end;
              $80..$ff:
               begin
                if Index[cptr] and 64 <> 0 then
                 begin
                  Incr(cptr);
                  if Index[cptr] and 15 <> 0 then
                   begin
                    Incr(cptr);
                    if f61 then
                     begin
                      j1 := cptr + 1;
                      f61 := False
                     end;
                    case Index[cptr - 1] and 15 - 1 of
                    4:
                     if f41 then
                      begin
                       b := Index[cptr] and 31;
                       if b = 0 then b := 32
                      end;
                    5:
                     if f41 then
                      begin
                       b := (b + Index[cptr]) and 31;
                       if b = 0 then b := 32
                      end
                    end
                   end
                 end
               end
              end;
              Incr(cptr);
              if f61 then j1 := cptr;
              break
             end;
            $60..$6e:
             begin
              Incr(cptr);
              if f61 then j1 := cptr + 1;
              case Index[cptr - 1] - $60 - 1 of
              4:
               if f41 then
                begin
                 b := Index[cptr] and 31;
                 if b = 0 then b := 32
                end;
              5:if f41 then
               begin
                b := (b + Index[cptr]) and 31;
                if b = 0 then b := 32
               end
              end;
              break
             end;
            $6f..$7f:
             begin
              if Index[cptr] <> $6f then
               begin
                Incr(cptr);
                if f61 then j1 := cptr + 1;
                case Index[cptr - 1] - $6f - 1 of
                4:
                 if f41 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f41 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end
              else
               j1 := cptr + 1;
              break
             end;
            $80..$bf:
             begin
              if (Index[cptr] in [$80..$9f]) and (pptr = pptr0) then inc(Nt);
              j1 := cptr + 1;
              if Index[cptr] in [$a0..$bf] then
               begin
                a1 := Index[cptr] and 15;
                if Index[cptr] and 16 = 0 then break;
                if a1 <> 0 then f71 := True
               end;
              cptr := j11;
              f61 := False;
              if Index[cptr] in [0..$7f] then
               begin
                Incr(cptr);
                case Index[cptr] of
                0..$7f:
                 begin
                  Incr(cptr);
                  if f61 then j1 := cptr + 1;
                  case Index[cptr - 1] - 1 of
                  4:
                   if f41 then
                    begin
                     b := Index[cptr] and 31;
                     if b = 0 then b := 32
                    end;
                   5:
                    if f41 then
                     begin
                      b := (b + Index[cptr]) and 31;
                      if b = 0 then b := 32
                     end
                   end
                 end;
                $80..$ff:
                 begin
                  if Index[cptr] and 64 <> 0 then
                   begin
                    Incr(cptr);
                    if Index[cptr] and 15 <> 0 then
                     begin
                      Incr(cptr);
                      if f61 then j1 := cptr + 1;
                      case (Index[cptr - 1]) and 15 - 1 of
                      4:
                       if f41 then
                        begin
                         b := Index[cptr] and 31;
                         if b = 0 then b := 32
                        end;
                      5:
                       if f41 then
                        begin
                         b := (b + Index[cptr]) and 31;
                         if b = 0 then b := 32
                        end
                      end
                     end
                   end
                 end
                end
               end;
              break
             end;
            $c0..$ff:
             begin
              j1 := cptr + 1;
              j11 := cptr;
              break
             end
            end
           until False
          end;
         if a2 <> 0 then
          begin
           dec(a2);
           if f72 then
            begin
             cptr := j22;
             f62 := False;
             if Index[cptr] in [0..$7f] then
              begin
               incr(cptr);
               case Index[cptr] of
               0..$7f:
                begin
                 incr(cptr);
                 if f62 then j2 := cptr + 1;
                 case Index[cptr - 1] - 1 of
                 4:
                  if f42 then
                   begin
                    b := Index[cptr] and 31;
                    if b = 0 then b := 32
                   end;
                 5:
                  if f42 then
                   begin
                    b := (b + Index[cptr]) and 31;
                    if b = 0 then b := 32
                   end
                 end
                end;
               $80..$ff:
                begin
                 if Index[cptr] and 64 <> 0 then
                  begin
                   incr(cptr);
                   if Index[cptr] and 15 <> 0 then
                    begin
                     incr(cptr);
                     if f62 then j2 := cptr + 1;
                     case Index[cptr - 1] and 15 - 1 of
                     4:
                      if f42 then
                       begin
                        b := Index[cptr] and 31;
                        if b = 0 then b := 32
                       end;
                     5:
                      if f42 then
                       begin
                        b := (b + Index[cptr]) and 31;
                        if b = 0 then b := 32
                       end
                     end
                    end
                  end
                end
               end
              end
            end
          end
         else
          begin
           if j2 >= 65536 then RaiseBadFileStructure;
           cptr := j2;
           f62 := True;
           f72 := False;
           repeat
            case Index[cptr] of
            0..$5f:
             begin
              if pptr = pptr0 then inc(Nt);
              j22 := cptr;
              Incr(cptr);
              case Index[cptr] of
              0..$7f:
               begin
                Incr(cptr);
                if f62 then
                 begin
                  j2 := cptr + 1;
                  f62 := False
                 end;
                case Index[cptr - 1] - 1 of
                4:
                 if f42 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f42 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end;
              $80..$ff:
               begin
                if Index[cptr] and 64 <> 0 then
                 begin
                  Incr(cptr);
                  if Index[cptr] and 15 <> 0 then
                   begin
                    Incr(cptr);
                    if f62 then
                     begin
                      j2 := cptr + 1;
                      f62 := False
                     end;
                    case Index[cptr - 1] and 15 - 1 of
                    4:
                     if f42 then
                      begin
                       b := Index[cptr] and 31;
                       if b = 0 then b := 32
                      end;
                    5:
                     if f42 then
                      begin
                       b := (b + Index[cptr]) and 31;
                       if b = 0 then b := 32
                      end
                    end
                   end
                 end
               end
              end;
              incr(cptr);
              if f62 then j2 := cptr;
              break
             end;
            $60..$6e:
             begin
              incr(cptr);
              if f62 then j2 := cptr + 1;
              case Index[cptr - 1] - $60 - 1 of
              4:
               if f42 then
                begin
                 b := Index[cptr] and 31;
                 if b = 0 then b := 32
                end;
              5:
               if f42 then
                begin
                 b := (b + Index[cptr]) and 31;
                 if b = 0 then b := 32
                end
              end;
              break
             end;
            $6f..$7f:
             begin
              if Index[cptr] <> $6f then
               begin
                incr(cptr);
                if f62 then j2 := cptr + 1;
                case Index[cptr - 1] - $6f - 1 of
                4:
                 if f42 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f42 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end
              else
               j2 := cptr + 1;
              break
             end;
            $80..$bf:
             begin
              if (Index[cptr] in [$80..$9f]) and (pptr = pptr0) then inc(Nt);
              j2 := cptr + 1;
              if not (Index[cptr] in [$80..$9f]) then
               begin
                a2 := Index[cptr] and 15;
                if Index[cptr] and 16 = 0 then break;
                if a2 <> 0 then f72 := True
               end;
              cptr := j22;
              f62 := False;
              if Index[cptr] in [0..$7f] then
               begin
                incr(cptr);
                case Index[cptr] of
                0..$7f:
                 begin
                  incr(cptr);
                  if f62 then j2 := cptr + 1;
                  case Index[cptr - 1] - 1 of
                  4:
                   if f42 then
                    begin
                     b := Index[cptr] and 31;
                     if b = 0 then b := 32
                    end;
                  5:
                   if f42 then
                    begin
                     b := (b + Index[cptr]) and 31;
                     if b = 0 then b := 32
                    end
                  end
                 end;
                $80..$ff:
                 begin
                  if Index[cptr] and 64 <> 0 then
                   begin
                    incr(cptr);
                    if Index[cptr] and 15 <> 0 then
                     begin
                      incr(cptr);
                      if f62 then j2 := cptr + 1;
                      case Index[cptr - 1] and 15 - 1 of
                      4:
                       if f42 then
                        begin
                         b := Index[cptr] and 31;
                         if b = 0 then b := 32
                        end;
                      5:
                       if f42 then
                        begin
                         b := (b + Index[cptr]) and 31;
                         if b = 0 then b := 32
                        end
                      end
                     end
                   end
                 end
                end
               end;
              break
             end;
            $c0..$ff:
             begin
              j2 := cptr + 1;
              j22 := cptr;
              break
             end
            end
           until False
          end;
         if a3 <> 0 then
          begin
           Dec(a3);
           if f73 then
            begin
             cptr := j33;
             f63 := False;
             if Index[cptr] in [0..$7f] then
              begin
               incr(cptr);
               case Index[cptr] of
               0..$7f:
                begin
                 incr(cptr);
                 if f63 then j3 := cptr + 1;
                 case Index[cptr - 1] - 1 of
                 4:
                  if f43 then
                   begin
                    b := Index[cptr] and 31;
                    if b = 0 then b := 32
                   end;
                 5:
                  if f43 then
                   begin
                    b := (b + Index[cptr]) and 31;
                    if b = 0 then b := 32
                   end
                 end
                end;
               $80..$ff:
                begin
                 if Index[cptr] and 64 <> 0 then
                  begin
                   Incr(cptr);
                   if Index[cptr] and 15 <> 0 then
                    begin
                     Incr(cptr);
                     if f63 then j3 := cptr + 1;
                     case Index[cptr - 1] and 15 - 1 of
                     4:
                      if f43 then
                       begin
                        b := Index[cptr] and 31;
                        if b = 0 then b := 32
                       end;
                     5:
                      if f43 then
                       begin
                        b := (b + Index[cptr]) and 31;
                        if b = 0 then b := 32
                       end
                     end
                    end
                  end
                end
               end
             end
            end
          end
         else
          begin
           if j3 >= 65536 then RaiseBadFileStructure;
           cptr := j3;
           f63 := True;
           f73 := False;
           repeat
            case Index[cptr] of
            0..$5f:
             begin
              if pptr = pptr0 then inc(Nt); 
              j33 := cptr;
              Incr(cptr);
              case Index[cptr] of
              0..$7f:
               begin
                Incr(cptr);
                if f63 then
                 begin
                  j3 := cptr + 1;
                  f63 := False
                 end;
                case Index[cptr - 1] - 1 of
                4:
                 if f43 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f43 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end;
              $80..$ff:
               begin
                if Index[cptr] and 64 <> 0 then
                 begin
                  Incr(cptr);
                  if Index[cptr] and 15 <> 0 then
                   begin
                    Incr(cptr);
                    if f63 then
                     begin
                      j3 := cptr + 1;
                      f63 := False
                     end;
                    case Index[cptr - 1] and 15 - 1 of
                    4:
                     if f43 then
                      begin
                       b := Index[cptr] and 31;
                       if b = 0 then b := 32
                      end;
                    5:
                     if f43 then
                      begin
                       b := (b + Index[cptr]) and 31;
                       if b = 0 then b := 32
                      end
                    end
                   end
                 end
               end
              end;
              incr(cptr);
              if f63 then j3 := cptr;
              break
             end;
            $60..$6e:
             begin
              incr(cptr);
              if f63 then j3 := cptr + 1;
              case Index[cptr - 1] - $60 - 1 of
              4:
               if f43 then
                begin
                 b := Index[cptr] and 31;
                 if b = 0 then b := 32
                end;
              5:
               if f43 then
                begin
                 b := (b + Index[cptr]) and 31;
                 if b = 0 then b := 32
                end
              end;
              break
             end;
            $6f..$7f:
             begin
              if Index[cptr] <> $6f then
               begin
                Incr(cptr);
                if f63 then j3 := cptr + 1;
                case Index[cptr - 1] - $6f - 1 of
                4:
                 if f43 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f43 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end
              else
               j3 := cptr + 1;
              break
             end;
            $80..$bf:
             begin
              if (Index[cptr] in [$80..$9f]) and (pptr = pptr0) then inc(Nt);
              j3 := cptr + 1;
              if not (Index[cptr] in [$80..$9f]) then
               begin
                a3 := Index[cptr] and 15;
                if Index[cptr] and 16 = 0 then break;
                if a3 <> 0 then f73 := True
               end;
              cptr := j33;
              f63 := False;
              if Index[cptr] in [0..$7f] then
               begin
                Incr(cptr);
                case Index[cptr] of
                0..$7f:
                 begin
                  Incr(cptr);
                  if f63 then j3 := cptr + 1;
                  case Index[cptr - 1] - 1 of
                   4:
                    if f43 then
                     begin
                      b := Index[cptr] and 31;
                      if b = 0 then b := 32
                     end;
                   5:
                    if f43 then
                     begin
                      b := (b + Index[cptr]) and 31;
                      if b = 0 then b := 32
                     end
                   end
                 end;
                $80..$ff:
                 begin
                  if Index[cptr] and 64 <> 0 then
                   begin
                    Incr(cptr);
                    if Index[cptr] and 15 <> 0 then
                     begin
                      Incr(cptr);
                      if f63 then j3 := cptr + 1;
                      case Index[cptr - 1] and 15 - 1 of
                      4:
                       if f43 then
                        begin
                         b := Index[cptr] and 31;
                         if b = 0 then b := 32
                        end;
                      5:
                       if f43 then
                        begin
                         b := (b + Index[cptr]) and 31;
                         if b = 0 then b := 32
                        end
                      end
                     end
                   end
                 end
                end
               end;
              break
             end;
            $c0..$ff:
             begin
              j3 := cptr + 1;
              j33 := cptr;
              break
             end;
            end
           until False
          end;
         Inc(tm,b)
        end
      end
    end
end;

procedure GetTimePT1(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 j1,j2,j3:longword;
 a1,a2,a3,a11,a22,a33:shortint;
 DLCatcher:integer;
 i:integer;
begin
   with Module^ do
    begin
     b := PT1_Delay;
     a1 := 0; a2 := 0; a3 := 0;
     a11 := 0; a22 := 0; a33 := 0;
     DLCatcher := 16384;
     for i := 0 to PT1_NumberOfPositions - 1 do
      begin
       if i = PT1_LoopPosition then Lp := tm;
       j1 := WordPtr(@Index[PT1_PatternsPointer +
                                        PT1_PositionList[i] * 6])^;
       j2 := WordPtr(@Index[PT1_PatternsPointer +
                                        PT1_PositionList[i] * 6 + 2])^;
       j3 := WordPtr(@Index[PT1_PatternsPointer +
                                        PT1_PositionList[i] * 6 + 4])^;
       repeat
        Dec(a1);
        if a1 < 0 then
         begin
          if Index[j1] = 255 then break;
           repeat
            case Index[j1] of
            0..$5f:
             begin
              a1 := a11;
              Incr(j1);
              if i = 0 then inc(Nt);
              break
             end;
            $80,$90:
             begin
              a1 := a11;
              Incr(j1);
              break
             end;
            $82..$8f:
             Inc(j1,2);
            $b1..$fe:
             a11 := Index[j1] - $b1;
            $91..$a0:
             b := Index[j1] - $91;
            end;
            Incr(j1)
           until False
         end;
        Dec(a2);
        if a2 < 0 then
         repeat
          case Index[j2] of
          0..$5f:
           begin
            a2 := a22;
            Incr(j2);
            if i = 0 then inc(Nt);
            break
           end;
          $80,$90:
           begin
            a2 := a22;
            Incr(j2);
            break
           end;
          $82..$8f:
           Inc(j2,2);
          $b1..$fe:
           a22 := Index[j2] - $b1;
          $91..$a0:
           b := Index[j2] - $91
          end;
          Incr(j2)
         until False;
        Dec(a3);
        if a3 < 0 then
         repeat
          case Index[j3] of
          0..$5f:
           begin
            a3 := a33;
            Incr(j3);
            if i = 0 then inc(Nt);
            break
           end;
          $80,$90:
           begin
            a3 := a33;
            Incr(j3);
            break
           end;
          $82..$8f:
           Inc(j3,2);
          $b1..$fe:
           a33 := Index[j3] - $b1;
          $91..$a0:
           b := Index[j3] - $91
          end;
          Incr(j3)
         until False;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure
       until False
      end
    end
end;

procedure GetTimeFLS(Module:PModTypes;var Tm,Nt:integer);
var
 b:byte;
 a1,a11:shortint;
 i:integer;
 pptr:longword;
 j1:longword;
begin
   with Module^ do
    begin
     b := Index[FLS_PositionsPointer];
     a1 := 0; a11 := 0; i := 0;
     repeat
      pptr := i + FLS_PositionsPointer + 1;
      if pptr >= 65536 then RaiseBadFileStructure;
      if Index[pptr] = 0 then break;
      j1 := FLS_PatternsPointers[Index[pptr]].PatternA;
      repeat
       Dec(a1);
       if a1 < 0 then
        begin
         if Index[j1] = 255 then break;
         repeat
          case Index[j1] of
          0..$5f:
           begin
            if i = 0 then inc(Nt);
            Incr(j1);
            a1 := a11;
            break
           end;
          $80,$81:
           begin
            Incr(j1);
            a1 := a11;
            break
           end;
          $82..$8e:
           Inc(j1);
          $8f..$ff:
           a11 := Index[j1] - $a1
          end;
          Incr(j1)
         until False
        end;
       Inc(tm,b)
      until False;
      Inc(i)
     until False;

     pptr := FLS_PositionsPointer + 1;
     if Index[pptr] = 0 then exit;
     j1 := FLS_PatternsPointers[Index[pptr]].PatternB;
     while Index[j1] <> 255 do
      repeat
       case Index[j1] of
       0..$5f:
        begin
         inc(Nt);
         Incr(j1);
         break
        end;
       $80,$81:
        begin
         Incr(j1);
         break
        end;
       $82..$8e:
        Inc(j1);
       end;
       Incr(j1)
      until False;

     j1 := FLS_PatternsPointers[Index[pptr]].PatternC;
     while Index[j1] <> 255 do
      repeat
       case Index[j1] of
       0..$5f:
        begin
         inc(Nt);
         Incr(j1);
         break
        end;
       $80,$81:
        begin
         Incr(j1);
         break
        end;
       $82..$8e:
        Inc(j1);
       end;
       Incr(j1)
      until False

    end
end;}

procedure GetTimeGTR(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 a:byte;
 a1:shortint;
 flg:boolean;
 j1:longword;

  begin
   with Module^ do
    begin
     a := 0; a1 := 0; flg := False;
     j1 := GTR_PatternsPointers[GTR_Positions[0] div 6].PatternA;
     repeat
      Dec(a1);
      if a1 < 0 then
       begin
        a1 := 0;
        while Index[j1] = 255 do
         begin
          Inc(a);
          flg := a >= GTR_NumberOfPositions;
          if flg then break;
          if a = GTR_LoopPosition then Lp := tm;
          j1 := GTR_PatternsPointers[Module^.GTR_Positions[a] div 6].PatternA
         end;
        if flg then break;
        repeat
         case Index[j1] of
         0..$5f,$D0..$DF:
          begin
           Incr(j1);
           if a = 0 then inc(Nt);
           break;
          end;
         $80..$BF:
          a1 := Index[j1] - $80;
         $C0..$CF:
          Inc(j1);
         $E0:
          if GTR_ID[3] <> #$10 then
           begin
            Incr(j1);
            break
           end
         end;
         Incr(j1)
        until False
       end;
      Inc(tm,GTR_Delay)
     until False;
     j1 := GTR_PatternsPointers[GTR_Positions[0] div 6].PatternB;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        inc(Nt);
       $C0..$CF:
        Inc(j1);
       end;
       Incr(j1);
      end;

     j1 := GTR_PatternsPointers[GTR_Positions[0] div 6].PatternC;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        inc(Nt);
       $C0..$CF:
        Inc(j1);
       end;
       Incr(j1);
      end;

    end;
end;

procedure GetTimeSTC(Module:PModTypes;var Tm,Nt:integer);
var
 i,j:integer;
 j1,j2:longword;
 a:byte;
begin
   with Module^ do
    begin
     j := -1;
     repeat
      inc(j);
      j2 := ST_PositionsPointer + j * 2;
      incr(j2);
      j2 := Index[j2];
      i := -1;
      repeat
       inc(i);
       j1 := ST_PatternsPointer + 7 * i;
       if j1 >= 65535 then RaiseBadFileStructure
      until Index[j1] = j2;
      j1 := PWord(@Index[j1 + 1])^;
      a := 1;
      while Index[j1] <> 255 do
       begin
        case Index[j1] of
        0..$5f:
         begin
          Inc(tm,a);
          if j = 0 then Inc(Nt);
         end;
        $80,$81:
         Inc(tm,a);
        $a1..$e0:
         a := Index[j1] - $a0;
        $83..$8e:
         inc(j1);
        end;
        incr(j1);
       end
     until j = Index[ST_PositionsPointer];
     tm := tm * ST_Delay;

     j2 := ST_PositionsPointer;
     incr(j2);
     j2 := Index[j2];
     i := -1;
     repeat
      inc(i);
      j1 := ST_PatternsPointer + 7 * i;
      if j1 >= 65535 then RaiseBadFileStructure
     until Index[j1] = j2;
     j2 := j1;
     j1 := PWord(@Index[j1 + 1 + 2])^;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        Inc(Nt);
       $83..$8e:
        inc(j1);
       end;
       incr(j1);
      end;

     j1 := PWord(@Index[j2 + 1 + 4])^;
     while Index[j1] <> 255 do
      begin
       case Index[j1] of
       0..$5f:
        Inc(Nt);
       $83..$8e:
        inc(j1);
       end;
       incr(j1);
      end;

    end;
end;

procedure GetTimeASC(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 i:integer;
 j1,j2,j3:longword;
 b:byte;
 a1,a2,a3,a11,a22,a33:shortint;
 Env1,Env2,Env3:boolean;
 DLCatcher:integer;
begin
    a1 := 0; a2 := 0; a3 := 0;
    a11 := 0; a22 := 0; a33 := 0;
    Env1 := False; Env2 := False; Env3 := False;
    with Module^ do
     begin
      b := ASC1_Delay;
      DLCatcher := 16384;
      for i := 0 to ASC1_Number_Of_Positions - 1 do
       begin
        if ASC1_LoopingPosition = i then Lp := tm;
        j1 := PWord(@Index[ASC1_PatternsPointers + 6 * Index[i + 9]])^ +
                              ASC1_PatternsPointers;
        j2 := PWord(@Index[ASC1_PatternsPointers + 6 * Index[i + 9] + 2])^ +
                              ASC1_PatternsPointers;
        j3 := PWord(@Index[ASC1_PatternsPointers + 6 * Index[i + 9] + 4])^ +
                              ASC1_PatternsPointers;
        repeat
         dec(a1);
         if a1 < 0 then
          begin
           if Index[j1] = 255 then break;
           repeat
            case Index[j1] of
            0..$55:
             begin
              a1 := a11;
              incr(j1);
              if Env1 then incr(j1);
              if i = 0 then inc(Nt);
              break;
             end;
            $56..$5f:
             begin
              a1 := a11;
              incr(j1);
              break
             end;
            $60..$9f:
             a11 := Index[j1] - $60;
            $e0:
             Env1 := True;
            $e1..$ef:
             Env1 := False;
            $f0,$f5..$f7,$f9,$fb:
             inc(j1);
            $f4:
             begin
              incr(j1);
              b := Index[j1]
             end
            end;
            incr(j1)
           until False;
          end;
         dec(a2);
         if a2 < 0 then
          repeat
           case Index[j2] of
           0..$55:
            begin
             a2 := a22;
             incr(j2);
             if Env2 then incr(j2);
             if i = 0 then inc(Nt);
             break;
            end;
           $56..$5f:
            begin
             a2 := a22;
             incr(j2);
             break
            end;
           $60..$9f:
            a22 := Index[j2] - $60;
           $e0:
            Env2 := True;
           $e1..$ef:
            Env2 := False;
           $f0,$f5..$f7,$f9,$fb:
            inc(j2);
           $f4:
            begin
             incr(j2);
             b := Index[j2]
            end
           end;
           incr(j2)
          until False;
         dec(a3);
         if a3 < 0 then
          repeat
           case Module^.Index[j3] of
           0..$55:
            begin
             a3 := a33;
             incr(j3);
             if Env3 then incr(j3);
             if i = 0 then inc(Nt);
             break;
            end;
           $56..$5f:
            begin
             a3 := a33;
             incr(j3);
             break
            end;
           $60..$9f:
            a33 := Index[j3] - $60;
           $e0:
            env3 := True;
           $e1..$ef:
            env3 := False;
           $f0,$f5..$f7,$f9,$fb:
            inc(j3);
           $f4:
            begin
             incr(j3);
             b := Index[j3]
            end
           end;
           incr(j3)
          until False;
         Inc(tm,b);
         Dec(DLCatcher);
         if DLCatcher < 0 then RaiseBadFileStructure
        until False
       end
     end
end;

procedure GetTimeSTP(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 a:byte;
 i:integer;
 j1:longword;
begin
   a := 1;
   with Module^ do
    begin
     for i := 0 to Index[STP_PositionsPointer] - 1 do
      begin
       if i = Index[STP_PositionsPointer + 1] then
        Lp := tm * STP_Delay;
       j1 := PWord(@Index[STP_PatternsPointer +
                      Index[STP_PositionsPointer + 2 + i * 2]])^;
       while Index[j1] <> 0 do
        begin
         case Index[j1] of
         1..$60:
          begin
           Inc(tm,a);
           if i = 0 then inc(Nt);
          end;
         $d0..$ef:
          Inc(tm,a);
         $80..$BF:
          a := Index[j1] - $7f;
         $c0..$cf,$f0:
          inc(j1)
         end;
         incr(j1)
        end
      end;
     tm := tm * STP_Delay;

     j1 := PWord(@Index[STP_PatternsPointer + 2 +
                      Index[STP_PositionsPointer + 2]])^;
     while Index[j1] <> 0 do
      begin
       case Index[j1] of
       1..$60:
        inc(Nt);
       $c0..$cf,$f0:
        inc(j1);
       end;
       incr(j1);
      end;

     j1 := PWord(@Index[STP_PatternsPointer + 4 +
                      Index[STP_PositionsPointer + 2]])^;
     while Index[j1] <> 0 do
      begin
       case Index[j1] of
       1..$60:
        inc(Nt);
       $c0..$cf,$f0:
        inc(j1);
       end;
       incr(j1);
      end;

    end;
end;

procedure GetTimePT2(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 i:integer;
 b:byte;
 a1,a2,a3,a11,a22,a33:shortint;
 DLCatcher:integer;
 j1,j2,j3:longword;
begin
   with Module^ do
    begin
     b := PT2_Delay;
     a1 := 0; a2 := 0; a3 := 0;
     a11 := 0; a22 := 0; a33 := 0;
     DLCatcher := 16384;
     i := 0;
     repeat
       if i >= 65536-131 then RaiseBadFileStructure;
       if shortint(PT2_PositionList[i]) < 0 then break;
       if i = PT2_LoopPosition then Lp := tm;
       j1 := PWord(@Index[PT2_PatternsPointer +
                                PT2_PositionList[i] * 6])^;
       j2 := PWord(@Index[PT2_PatternsPointer +
                                PT2_PositionList[i] * 6 + 2])^;
       j3 := PWord(@Index[PT2_PatternsPointer +
                                PT2_PositionList[i] * 6 + 4])^;
       repeat
        dec(a1);
        if a1 < 0 then
         begin
          if Index[j1] = 0 then break;
          repeat
           case Index[j1] of
           $80..$df:
            begin
             a1 := a11;
             incr(j1);
             if i = 0 then inc(Nt);
             break;
            end;
           $70,$e0:
            begin
             a1 := a11;
             incr(j1);
             break;
            end;
           $71..$7e:
            inc(j1,2);
           $20..$5f:
            a11 := Index[j1] - $20;
           $f:
            begin
             incr(j1);
             b := Index[j1]
            end;
           1..$b,$e:
            inc(j1);
           $d:
            inc(j1,3)
           end;
           incr(j1)
          until False
         end;
        dec(a2);
        if a2 < 0 then
         repeat
          case Index[j2] of
          $80..$df:
           begin
            a2 := a22;
            incr(j2);
            if i = 0 then inc(Nt);
            break;
           end;
          $70,$e0:
           begin
            a2 := a22;
            incr(j2);
            break;
           end;
          $71..$7e:
           inc(j2,2);
          $20..$5f:
           a22 := Index[j2] - $20;
          $f:
           begin
            incr(j2);
            b := Index[j2]
           end;
          1..$b,$e:
           inc(j2);
          $d:
           inc(j2,3)
          end;
          incr(j2)
         until False;
        dec(a3);
        if a3 < 0 then
         repeat
          case Index[j3] of
          $80..$df:
           begin
            a3 := a33;
            incr(j3);
            if i = 0 then inc(Nt);
            break;
           end;
          $70,$e0:
           begin
            a3 := a33;
            incr(j3);
            break;
           end;
          $71..$7e:
           inc(j3,2);
          $20..$5f:
           a33 := Index[j3] - $20;
          $f:
           begin
            incr(j3);
            b := Index[j3]
           end;
          1..$b,$e:
           inc(j3);
          $d:
           inc(j3,3)
          end;
          incr(j3)
         until False;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure
       until False;
       inc(i)
     until False
    end
end;

procedure GetTimePT3(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 TS:integer;
 vars:array[0..1] of record
  a1,a2,a3,a11,a22,a33:shortint;
  j1,j2,j3:longword;
 end;

 procedure GetPatPtrs(n,i:integer);
 begin
  if (i < 0) or (i > 84 * 3) or (i mod 3 <> 0) then RaiseBadFileStructure;
  with vars[n],Module^ do
   begin
    j1 := PWord(@Index[PT3_PatternsPointer + i * 2])^;
    j2 := PWord(@Index[PT3_PatternsPointer + i * 2 + 2])^;
    j3 := PWord(@Index[PT3_PatternsPointer + i * 2 + 4])^;
   end;
 end;

 function PatInt(n,i:integer):boolean;
 var
  j,c1,c2,c3,c4,c5,c8:integer;
 begin
 Result := False;
  with vars[n],Module^ do
   begin
        dec(a1);
        if a1 = 0 then
         begin
          if Index[j1] = 0 then exit;
          j := 0; c1 := 0; c2 := 0; c3 := 0; c4 := 0; c5 := 0; c8 := 0;
          repeat
           case Index[j1] of
           $50..$af:
            begin
             a1 := a11;
             incr(j1);
             if (n = 0) and (i = 0) then inc(Nt);
             break;
            end;
           $d0,$c0:
            begin
             a1 := a11;
             incr(j1);
             break;
            end;
           $10,$f0..$ff:
            inc(j1);
           $b2..$bf:
            inc(j1,2);
           $b1:
            begin
             incr(j1);
             a11 := Index[j1]
            end;
           $11..$1f:
            inc(j1,3);
           1:
            begin
             inc(j);
             c1 := j
            end;
           2:
            begin
             inc(j);
             c2 := j
            end;
           3:
            begin
             inc(j);
             c3 := j
            end;
           4:
            begin
             inc(j);
             c4 := j
            end;
           5:
            begin
             inc(j);
             c5 := j
            end;
           8:
            begin
             inc(j);
             c8 := j
            end;
           9:
            inc(j)
           end;
           incr(j1)
          until False;
          while j > 0 do
           begin
            if (j = c1) or (j = c8) then
             inc(j1,3)
            else if (j = c2) then
             inc(j1,5)
            else if (j = c3) or (j = c4) then
             inc(j1)
            else if (j = c5) then
             inc(j1,2)
            else
             begin
              b := Index[j1];
              inc(j1)
             end;
            if j1 >= 65536 then RaiseBadFileStructure;
            dec(j)
           end
         end;
        dec(a2);
        if a2 = 0 then
         begin
          j := 0; c1 := 0; c2 := 0; c3 := 0; c4 := 0; c5 := 0; c8 := 0;
          repeat
           case Index[j2] of
           $50..$af:
            begin
             a2 := a22;
             incr(j2);
             if (n = 0) and (i = 0) then inc(Nt);
             break;
            end;
           $d0,$c0:
            begin
             a2 := a22;
             incr(j2);
             break;
            end;
           $10,$f0..$ff:
            inc(j2);
           $b2..$bf:
            inc(j2,2);
           $b1:
            begin
             incr(j2);
             a22 := Index[j2]
            end;
           $11..$1f:
            inc(j2,3);
           1:
            begin
             inc(j);
             c1 := j
            end;
           2:
            begin
             inc(j);
             c2 := j
            end;
           3:
            begin
             inc(j);
             c3 := j
            end;
           4:
            begin
             inc(j);
             c4 := j
            end;
           5:
            begin
             inc(j);
             c5 := j
            end;
           8:
            begin
             inc(j);
             c8 := j
            end;
           9:
            inc(j)
           end;
           incr(j2)
          until False;
          while j > 0 do
           begin
            if (j = c1) or (j = c8) then
             inc(j2,3)
            else if (j = c2) then
             inc(j2,5)
            else if (j = c3) or (j = c4) then
             inc(j2)
            else if (j = c5) then
             inc(j2,2)
            else
             begin
              b := Index[j2];
              inc(j2)
             end;
            if j2 >= 65536 then RaiseBadFileStructure;
            dec(j)
           end
         end;
        dec(a3);
        if a3 = 0 then
         begin
          j := 0; c1 := 0; c2 := 0; c3 := 0; c4 := 0; c5 := 0; c8 := 0;
          repeat
           case Module^.Index[j3] of
           $50..$af:
            begin
             a3 := a33;
             incr(j3);
             if (n = 0) and (i = 0) then inc(Nt);
             break;
            end;
           $d0,$c0:
            begin
             a3 := a33;
             incr(j3);
             break;
            end;
           $10,$f0..$ff:
            inc(j3);
           $b2..$bf:
            inc(j3,2);
           $b1:
            begin
             incr(j3);
             a33 := Index[j3]
            end;
           $11..$1f:
            inc(j3,3);
           1:
            begin
             inc(j);
             c1 := j
            end;
           2:
            begin
             inc(j);
             c2 := j
            end;
           3:
            begin
             inc(j);
             c3 := j
            end;
           4:
            begin
             inc(j);
             c4 := j
            end;
           5:
            begin
             inc(j);
             c5 := j
            end;
           8:
            begin
             inc(j);
             c8 := j
            end;
           9:
            inc(j)
           end;
           incr(j3)
          until False;
          while j > 0 do
           begin
            if (j = c1) or (j = c8) then
             inc(j3,3)
            else if (j = c2) then
             inc(j3,5)
            else if (j = c3) or (j = c4) then
             inc(j3)
            else if (j = c5) then
             inc(j3,2)
            else
             begin
              b := Index[j3];
              inc(j3)
             end;
            if j3 >= 65536 then RaiseBadFileStructure;
            dec(j);
           end;
         end;
   end;
 Result := True;
 end;

var
 i:integer;
 DLCatcher:integer;

begin
   with Module^ do
    begin
     b := PT3_Delay; TS := $20;
     if PT3_MusicName[13] in ['7'..'9'] then
      TS := Ord(PT3_MusicName[98]);
     for i := 0 to 1 do
      with vars[i] do
       begin
        a11 := 1; a22 := 1; a33 := 1;
        DLCatcher := 256*256; //max 256 patterns 256 lines per pattern
       end;
     for i := 0 to PT3_NumberOfPositions - 1 do
      begin
       if i = PT3_LoopPosition then Lp := tm;
       GetPatPtrs(0,PT3_PositionList[i]);
       with vars[0] do
        begin
         a1 := 1; a2 := 1; a3 := 1;
        end;
       if TS <> $20 then
        begin
         GetPatPtrs(1,TS * 3 - 3 - PT3_PositionList[i]);
         with vars[1] do
          begin
           a1 := 1; a2 := 1; a3 := 1;
          end;
        end;
       repeat
        if not PatInt(0,i) then break;
        if TS <> $20 then
         if not PatInt(1,i) then break;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure;
       until False;
      end;
    end;
end;

procedure GetTimePSC(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 pptr,cptr,pptr0:longword;
 j1,j2,j3:longword;
 a1,a2,a3:shortint;
 i:integer;
begin
   with Module^ do
    begin
     b := PSC_Delay;
     pptr := PSC_PatternsPointer;
     incr(pptr);
     pptr0 := pptr + 8;
     while Index[pptr] <> 255 do
      begin
       inc(pptr,8);
       if pptr >= 65536 then RaiseBadFileStructure
      end;
     if pptr >= 65536 - 2 then RaiseBadFileStructure;
     cptr := PWord(@Index[pptr + 1])^;
     incr(cptr);
     pptr := PSC_PatternsPointer;
     incr(pptr);
     while Index[pptr] <> 255 do
      begin
       if pptr = cptr then Lp := tm;
       if pptr >= 65536 - 6 then RaiseBadFileStructure;
       j1 := PWord(@Index[pptr + 1])^;
       j2 := PWord(@Index[pptr + 3])^;
       j3 := PWord(@Index[pptr + 5])^;
       Inc(pptr,8);
       if pptr >= 65536 then RaiseBadFileStructure;
       a1 := 1; a2 := 1; a3 := 1;
       for i := 1 to Index[pptr - 8] do
        begin
         dec(a1);
         if a1 = 0 then
          repeat
           case Index[j1] of
           $c0..$ff:
            begin
             a1 := Index[j1] - $bf;
             inc(j1);
             break
            end;
           $67..$6d,$6f..$7b:
            inc(j1);
           $6e:
            begin
             incr(j1);
             b := Index[j1]
            end;
           $0..$56:
            if pptr = pptr0 then inc(Nt);
           end;
           incr(j1)
          until False;
         dec(a2);
         if a2 = 0 then
          repeat
           case Index[j2] of
           $c0..$ff:
            begin
             a2 := Index[j2] - $bf;
             inc(j2);
             break
            end;
           $67..$6d,$6f..$79,$7b:
            inc(j2);
           $6e:
            begin
             incr(j2);
             b := Index[j2]
            end;
           $7a:
            inc(j2,3);
           $0..$56:
            if pptr = pptr0 then inc(Nt);
           end;
           incr(j2)
          until False;
         dec(a3);
         if a3 = 0 then
          repeat
           case Index[j3] of
           $c0..$ff:
            begin
             a3 := Index[j3] - $bf;
             inc(j3);
             break
            end;
           $67..$6d,$6f..$7b:
            inc(j3);
           $6e:
            begin
             incr(j3);
             b := Index[j3];
            end;
           $0..$56:
            if pptr = pptr0 then inc(Nt);
           end;
           incr(j3);
          until False;
         Inc(tm,b);
        end;
      end;
    end;
end;

procedure GetTimeFTC(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 i:integer;
 j1,j2,j3:longword;
 a1,a2,a3:shortint;
 DLCatcher:integer;
begin
   with Module^ do
    begin
     b := FTC_Delay;
     i := 0;
     repeat
      if FTC_Positions[i].Pattern = 255 then break;
      if i = FTC_Loop_Position then Lp := tm;
      j1 := PWord(@Index[FTC_PatternsPointer +
                           FTC_Positions[i].Pattern * 6])^;
      j2 := PWord(@Index[FTC_PatternsPointer +
                           FTC_Positions[i].Pattern * 6 + 2])^;
      j3 := PWord(@Index[FTC_PatternsPointer +
                           FTC_Positions[i].Pattern * 6 + 4])^;
      Inc(i);
      if i >= (65536 - $d4) div 2 then RaiseBadFileStructure;
      a1 := 0; a2 := 0; a3 := 0;
      DLCatcher := 256;
      repeat
       Dec(a1);
       if a1 < 0 then
        begin
         if Index[j1] = 255 then break;
         repeat
          case Index[j1] of
          $60..$cb:
           begin
            a1 := 0;
            Incr(j1);
            if i = 1 then inc(Nt);
            break;
           end;
          $30:
           begin
            a1 := 0;
            Incr(j1);
            break;
           end;
          $40..$5f:
           begin
            a1 := Index[j1] - $40;
            Incr(j1);
            break
           end;
          $ee,$ef:
           Inc(j1);
          $31..$3e,$ed:
           Inc(j1,2);
          $f0..$ff:
           begin
            Incr(j1);
            b := Index[j1]
           end
          end;
          Incr(j1)
         until False
        end;
        Dec(a2);
        if a2 < 0 then
         repeat
          case Index[j2]of
          $60..$cb:
           begin
            a2 := 0;
            Incr(j2);
            if i = 1 then inc(Nt);
            break;
           end;
          $30:
           begin
            a2 := 0;
            Incr(j2);
            break;
           end;
          $40..$5f:
           begin
            a2 := Index[j2] - $40;
            Incr(j2);
            break;
           end;
          $ee,$ef:
           inc(j2);
          $31..$3e,$ed:
           inc(j2,2);
          $f0..$ff:
           begin
            incr(j2);
            b := Index[j2]
           end
          end;
          Incr(j2)
         until False;
        Dec(a3);
        if a3 < 0 then
         repeat
          case Index[j3] of
          $60..$cb:
           begin
            a3 := 0;
            Incr(j3);
            if i = 1 then inc(Nt);
            break;
           end;
          $30:
           begin
            a3 := 0;
            Incr(j3);
            break;
           end;
          $40..$5f:
           begin
            a3 := Index[j3] - $40;
            Incr(j3);
            break
           end;
          $ee,$ef:
           inc(j3);
          $31..$3e,$ed:
           inc(j3,2);
          $f0..$ff:
           begin
            Incr(j3);
            b := Index[j3]
           end
          end;
          Incr(j3)
         until False;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure;
      until False;
     until False;
    end;
end;

procedure GetTimeSQT(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 pptr,pptr0,cptr:longword;
 f71,f72,f73,
 f61,f62,f63,
 f41,f42,f43:boolean;
 j1,j2,j3:longword;
 j11,j22,j33:word;
 b:byte;
 a1,a2,a3:shortint;
 i:integer;
begin
   with Module^ do
    begin
     pptr := SQT_PositionsPointer;
     pptr0 := pptr + 7;
     while Index[pptr] <> 0 do
      begin
       if pptr = SQT_LoopPointer then Lp := tm;
       f41 := Index[pptr] and 128 <> 0;
       j1 := PWord(@Index[byte(Index[pptr] * 2) + SQT_PatternsPointer])^;
       Incr(j1);
       Inc(pptr,2);
       if pptr >= 65536 then RaiseBadFileStructure;
       f42 := Index[pptr] and 128 <> 0;
       j2 := PWord(@Index[byte(Index[pptr] * 2) + SQT_PatternsPointer])^;
       Incr(j2);
       Inc(pptr,2);
       if pptr >= 65536 then RaiseBadFileStructure;
       f43 := Index[pptr] and 128 <> 0;
       j3 := PWord(@Index[byte(Index[pptr] * 2) + SQT_PatternsPointer])^;
       Incr(j3);
       Inc(pptr,2);
       if pptr >= 65536 then RaiseBadFileStructure;
       b := Index[pptr];
       Incr(pptr);
       a1 := 0; a2 := 0; a3 := 0;
       for i := 1 to Index[j1 - 1] do
        begin
         if a1 <> 0 then
          begin
           dec(a1);
           if f71 then
            begin
             cptr := j11;
             f61 := False;
             if Index[cptr] in [0..$7f] then
              begin
               Incr(cptr);
               case Index[cptr] of
               0..$7f:
                begin
                 Incr(cptr);
                 if f61 then j1 := cptr + 1;
                 case Index[cptr - 1] - 1 of
                 4:
                  if f41 then
                   begin
                    b := Index[cptr] and 31;
                    if b = 0 then b := 32
                   end;
                 5:
                  if f41 then
                   begin
                    b := (b + Index[cptr]) and 31;
                    if b = 0 then b := 32
                   end
                 end
                end;
               $80..$ff:
                begin
                 if Index[cptr] and 64 <> 0 then
                  begin
                   Incr(cptr);
                   if Index[cptr] and 15 <> 0 then
                    begin
                     Incr(cptr);
                     if f61 then j1 := cptr + 1;
                     case (Index[cptr - 1]) and 15 - 1 of
                     4:
                      if f41 then
                       begin
                        b := Index[cptr] and 31;
                        if b = 0 then b := 32
                       end;
                     5:
                      if f41 then
                       begin
                        b := (b + Index[cptr]) and 31;
                        if b = 0 then b := 32
                       end
                     end
                    end
                  end
                end
               end
              end
            end
          end
         else
          begin
           if j1 >= 65536 then RaiseBadFileStructure;
           cptr := j1;
           f61 := True;
           f71 := False;
           repeat
            case Index[cptr] of
            0..$5f:
             begin
              if pptr = pptr0 then inc(Nt);
              j11 := cptr;
              Incr(cptr);
              case Index[cptr] of
              0..$7f:
               begin
                Incr(cptr);
                if f61 then
                 begin
                  j1 := cptr + 1;
                  f61 := False
                 end;
                case Index[cptr - 1] - 1 of
                4:
                 if f41 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f41 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end;
              $80..$ff:
               begin
                if Index[cptr] and 64 <> 0 then
                 begin
                  Incr(cptr);
                  if Index[cptr] and 15 <> 0 then
                   begin
                    Incr(cptr);
                    if f61 then
                     begin
                      j1 := cptr + 1;
                      f61 := False
                     end;
                    case Index[cptr - 1] and 15 - 1 of
                    4:
                     if f41 then
                      begin
                       b := Index[cptr] and 31;
                       if b = 0 then b := 32
                      end;
                    5:
                     if f41 then
                      begin
                       b := (b + Index[cptr]) and 31;
                       if b = 0 then b := 32
                      end
                    end
                   end
                 end
               end
              end;
              Incr(cptr);
              if f61 then j1 := cptr;
              break
             end;
            $60..$6e:
             begin
              Incr(cptr);
              if f61 then j1 := cptr + 1;
              case Index[cptr - 1] - $60 - 1 of
              4:
               if f41 then
                begin
                 b := Index[cptr] and 31;
                 if b = 0 then b := 32
                end;
              5:if f41 then
               begin
                b := (b + Index[cptr]) and 31;
                if b = 0 then b := 32
               end
              end;
              break
             end;
            $6f..$7f:
             begin
              if Index[cptr] <> $6f then
               begin
                Incr(cptr);
                if f61 then j1 := cptr + 1;
                case Index[cptr - 1] - $6f - 1 of
                4:
                 if f41 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f41 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end
              else
               j1 := cptr + 1;
              break
             end;
            $80..$bf:
             begin
              if (Index[cptr] in [$80..$9f]) and (pptr = pptr0) then inc(Nt);
              j1 := cptr + 1;
              if Index[cptr] in [$a0..$bf] then
               begin
                a1 := Index[cptr] and 15;
                if Index[cptr] and 16 = 0 then break;
                if a1 <> 0 then f71 := True
               end;
              cptr := j11;
              f61 := False;
              if Index[cptr] in [0..$7f] then
               begin
                Incr(cptr);
                case Index[cptr] of
                0..$7f:
                 begin
                  Incr(cptr);
                  if f61 then j1 := cptr + 1;
                  case Index[cptr - 1] - 1 of
                  4:
                   if f41 then
                    begin
                     b := Index[cptr] and 31;
                     if b = 0 then b := 32
                    end;
                   5:
                    if f41 then
                     begin
                      b := (b + Index[cptr]) and 31;
                      if b = 0 then b := 32
                     end
                   end
                 end;
                $80..$ff:
                 begin
                  if Index[cptr] and 64 <> 0 then
                   begin
                    Incr(cptr);
                    if Index[cptr] and 15 <> 0 then
                     begin
                      Incr(cptr);
                      if f61 then j1 := cptr + 1;
                      case (Index[cptr - 1]) and 15 - 1 of
                      4:
                       if f41 then
                        begin
                         b := Index[cptr] and 31;
                         if b = 0 then b := 32
                        end;
                      5:
                       if f41 then
                        begin
                         b := (b + Index[cptr]) and 31;
                         if b = 0 then b := 32
                        end
                      end
                     end
                   end
                 end
                end
               end;
              break
             end;
            $c0..$ff:
             begin
              j1 := cptr + 1;
              j11 := cptr;
              break
             end
            end
           until False
          end;
         if a2 <> 0 then
          begin
           dec(a2);
           if f72 then
            begin
             cptr := j22;
             f62 := False;
             if Index[cptr] in [0..$7f] then
              begin
               incr(cptr);
               case Index[cptr] of
               0..$7f:
                begin
                 incr(cptr);
                 if f62 then j2 := cptr + 1;
                 case Index[cptr - 1] - 1 of
                 4:
                  if f42 then
                   begin
                    b := Index[cptr] and 31;
                    if b = 0 then b := 32
                   end;
                 5:
                  if f42 then
                   begin
                    b := (b + Index[cptr]) and 31;
                    if b = 0 then b := 32
                   end
                 end
                end;
               $80..$ff:
                begin
                 if Index[cptr] and 64 <> 0 then
                  begin
                   incr(cptr);
                   if Index[cptr] and 15 <> 0 then
                    begin
                     incr(cptr);
                     if f62 then j2 := cptr + 1;
                     case Index[cptr - 1] and 15 - 1 of
                     4:
                      if f42 then
                       begin
                        b := Index[cptr] and 31;
                        if b = 0 then b := 32
                       end;
                     5:
                      if f42 then
                       begin
                        b := (b + Index[cptr]) and 31;
                        if b = 0 then b := 32
                       end
                     end
                    end
                  end
                end
               end
              end
            end
          end
         else
          begin
           if j2 >= 65536 then RaiseBadFileStructure;
           cptr := j2;
           f62 := True;
           f72 := False;
           repeat
            case Index[cptr] of
            0..$5f:
             begin
              if pptr = pptr0 then inc(Nt);
              j22 := cptr;
              Incr(cptr);
              case Index[cptr] of
              0..$7f:
               begin
                Incr(cptr);
                if f62 then
                 begin
                  j2 := cptr + 1;
                  f62 := False
                 end;
                case Index[cptr - 1] - 1 of
                4:
                 if f42 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f42 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end;
              $80..$ff:
               begin
                if Index[cptr] and 64 <> 0 then
                 begin
                  Incr(cptr);
                  if Index[cptr] and 15 <> 0 then
                   begin
                    Incr(cptr);
                    if f62 then
                     begin
                      j2 := cptr + 1;
                      f62 := False
                     end;
                    case Index[cptr - 1] and 15 - 1 of
                    4:
                     if f42 then
                      begin
                       b := Index[cptr] and 31;
                       if b = 0 then b := 32
                      end;
                    5:
                     if f42 then
                      begin
                       b := (b + Index[cptr]) and 31;
                       if b = 0 then b := 32
                      end
                    end
                   end
                 end
               end
              end;
              incr(cptr);
              if f62 then j2 := cptr;
              break
             end;
            $60..$6e:
             begin
              incr(cptr);
              if f62 then j2 := cptr + 1;
              case Index[cptr - 1] - $60 - 1 of
              4:
               if f42 then
                begin
                 b := Index[cptr] and 31;
                 if b = 0 then b := 32
                end;
              5:
               if f42 then
                begin
                 b := (b + Index[cptr]) and 31;
                 if b = 0 then b := 32
                end
              end;
              break
             end;
            $6f..$7f:
             begin
              if Index[cptr] <> $6f then
               begin
                incr(cptr);
                if f62 then j2 := cptr + 1;
                case Index[cptr - 1] - $6f - 1 of
                4:
                 if f42 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f42 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end
              else
               j2 := cptr + 1;
              break
             end;
            $80..$bf:
             begin
              if (Index[cptr] in [$80..$9f]) and (pptr = pptr0) then inc(Nt);
              j2 := cptr + 1;
              if not (Index[cptr] in [$80..$9f]) then
               begin
                a2 := Index[cptr] and 15;
                if Index[cptr] and 16 = 0 then break;
                if a2 <> 0 then f72 := True
               end;
              cptr := j22;
              f62 := False;
              if Index[cptr] in [0..$7f] then
               begin
                incr(cptr);
                case Index[cptr] of
                0..$7f:
                 begin
                  incr(cptr);
                  if f62 then j2 := cptr + 1;
                  case Index[cptr - 1] - 1 of
                  4:
                   if f42 then
                    begin
                     b := Index[cptr] and 31;
                     if b = 0 then b := 32
                    end;
                  5:
                   if f42 then
                    begin
                     b := (b + Index[cptr]) and 31;
                     if b = 0 then b := 32
                    end
                  end
                 end;
                $80..$ff:
                 begin
                  if Index[cptr] and 64 <> 0 then
                   begin
                    incr(cptr);
                    if Index[cptr] and 15 <> 0 then
                     begin
                      incr(cptr);
                      if f62 then j2 := cptr + 1;
                      case Index[cptr - 1] and 15 - 1 of
                      4:
                       if f42 then
                        begin
                         b := Index[cptr] and 31;
                         if b = 0 then b := 32
                        end;
                      5:
                       if f42 then
                        begin
                         b := (b + Index[cptr]) and 31;
                         if b = 0 then b := 32
                        end
                      end
                     end
                   end
                 end
                end
               end;
              break
             end;
            $c0..$ff:
             begin
              j2 := cptr + 1;
              j22 := cptr;
              break
             end
            end
           until False
          end;
         if a3 <> 0 then
          begin
           Dec(a3);
           if f73 then
            begin
             cptr := j33;
             f63 := False;
             if Index[cptr] in [0..$7f] then
              begin
               incr(cptr);
               case Index[cptr] of
               0..$7f:
                begin
                 incr(cptr);
                 if f63 then j3 := cptr + 1;
                 case Index[cptr - 1] - 1 of
                 4:
                  if f43 then
                   begin
                    b := Index[cptr] and 31;
                    if b = 0 then b := 32
                   end;
                 5:
                  if f43 then
                   begin
                    b := (b + Index[cptr]) and 31;
                    if b = 0 then b := 32
                   end
                 end
                end;
               $80..$ff:
                begin
                 if Index[cptr] and 64 <> 0 then
                  begin
                   Incr(cptr);
                   if Index[cptr] and 15 <> 0 then
                    begin
                     Incr(cptr);
                     if f63 then j3 := cptr + 1;
                     case Index[cptr - 1] and 15 - 1 of
                     4:
                      if f43 then
                       begin
                        b := Index[cptr] and 31;
                        if b = 0 then b := 32
                       end;
                     5:
                      if f43 then
                       begin
                        b := (b + Index[cptr]) and 31;
                        if b = 0 then b := 32
                       end
                     end
                    end
                  end
                end
               end
             end
            end
          end
         else
          begin
           if j3 >= 65536 then RaiseBadFileStructure;
           cptr := j3;
           f63 := True;
           f73 := False;
           repeat
            case Index[cptr] of
            0..$5f:
             begin
              if pptr = pptr0 then inc(Nt);
              j33 := cptr;
              Incr(cptr);
              case Index[cptr] of
              0..$7f:
               begin
                Incr(cptr);
                if f63 then
                 begin
                  j3 := cptr + 1;
                  f63 := False
                 end;
                case Index[cptr - 1] - 1 of
                4:
                 if f43 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f43 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end;
              $80..$ff:
               begin
                if Index[cptr] and 64 <> 0 then
                 begin
                  Incr(cptr);
                  if Index[cptr] and 15 <> 0 then
                   begin
                    Incr(cptr);
                    if f63 then
                     begin
                      j3 := cptr + 1;
                      f63 := False
                     end;
                    case Index[cptr - 1] and 15 - 1 of
                    4:
                     if f43 then
                      begin
                       b := Index[cptr] and 31;
                       if b = 0 then b := 32
                      end;
                    5:
                     if f43 then
                      begin
                       b := (b + Index[cptr]) and 31;
                       if b = 0 then b := 32
                      end
                    end
                   end
                 end
               end
              end;
              incr(cptr);
              if f63 then j3 := cptr;
              break
             end;
            $60..$6e:
             begin
              incr(cptr);
              if f63 then j3 := cptr + 1;
              case Index[cptr - 1] - $60 - 1 of
              4:
               if f43 then
                begin
                 b := Index[cptr] and 31;
                 if b = 0 then b := 32
                end;
              5:
               if f43 then
                begin
                 b := (b + Index[cptr]) and 31;
                 if b = 0 then b := 32
                end
              end;
              break
             end;
            $6f..$7f:
             begin
              if Index[cptr] <> $6f then
               begin
                Incr(cptr);
                if f63 then j3 := cptr + 1;
                case Index[cptr - 1] - $6f - 1 of
                4:
                 if f43 then
                  begin
                   b := Index[cptr] and 31;
                   if b = 0 then b := 32
                  end;
                5:
                 if f43 then
                  begin
                   b := (b + Index[cptr]) and 31;
                   if b = 0 then b := 32
                  end
                end
               end
              else
               j3 := cptr + 1;
              break
             end;
            $80..$bf:
             begin
              if (Index[cptr] in [$80..$9f]) and (pptr = pptr0) then inc(Nt);
              j3 := cptr + 1;
              if not (Index[cptr] in [$80..$9f]) then
               begin
                a3 := Index[cptr] and 15;
                if Index[cptr] and 16 = 0 then break;
                if a3 <> 0 then f73 := True
               end;
              cptr := j33;
              f63 := False;
              if Index[cptr] in [0..$7f] then
               begin
                Incr(cptr);
                case Index[cptr] of
                0..$7f:
                 begin
                  Incr(cptr);
                  if f63 then j3 := cptr + 1;
                  case Index[cptr - 1] - 1 of
                   4:
                    if f43 then
                     begin
                      b := Index[cptr] and 31;
                      if b = 0 then b := 32
                     end;
                   5:
                    if f43 then
                     begin
                      b := (b + Index[cptr]) and 31;
                      if b = 0 then b := 32
                     end
                   end
                 end;
                $80..$ff:
                 begin
                  if Index[cptr] and 64 <> 0 then
                   begin
                    Incr(cptr);
                    if Index[cptr] and 15 <> 0 then
                     begin
                      Incr(cptr);
                      if f63 then j3 := cptr + 1;
                      case Index[cptr - 1] and 15 - 1 of
                      4:
                       if f43 then
                        begin
                         b := Index[cptr] and 31;
                         if b = 0 then b := 32
                        end;
                      5:
                       if f43 then
                        begin
                         b := (b + Index[cptr]) and 31;
                         if b = 0 then b := 32
                        end
                      end
                     end
                   end
                 end
                end
               end;
              break
             end;
            $c0..$ff:
             begin
              j3 := cptr + 1;
              j33 := cptr;
              break
             end;
            end
           until False
          end;
         Inc(tm,b)
        end
      end
    end
end;

procedure GetTimePT1(Module:PModTypes;var Tm,Lp,Nt:integer);
var
 b:byte;
 j1,j2,j3:longword;
 a1,a2,a3,a11,a22,a33:shortint;
 DLCatcher:integer;
 i:integer;
begin
   with Module^ do
    begin
     b := PT1_Delay;
     a1 := 0; a2 := 0; a3 := 0;
     a11 := 0; a22 := 0; a33 := 0;
     DLCatcher := 16384;
     for i := 0 to PT1_NumberOfPositions - 1 do
      begin
       if i = PT1_LoopPosition then Lp := tm;
       j1 := PWord(@Index[PT1_PatternsPointer +
                                        PT1_PositionList[i] * 6])^;
       j2 := PWord(@Index[PT1_PatternsPointer +
                                        PT1_PositionList[i] * 6 + 2])^;
       j3 := PWord(@Index[PT1_PatternsPointer +
                                        PT1_PositionList[i] * 6 + 4])^;
       repeat
        Dec(a1);
        if a1 < 0 then
         begin
          if Index[j1] = 255 then break;
           repeat
            case Index[j1] of
            0..$5f:
             begin
              a1 := a11;
              Incr(j1);
              if i = 0 then inc(Nt);
              break;
             end;
            $80,$90:
             begin
              a1 := a11;
              Incr(j1);
              break;
             end;
            $82..$8f:
             Inc(j1,2);
            $b1..$fe:
             a11 := Index[j1] - $b1;
            $91..$a0:
             b := Index[j1] - $91;
            end;
            Incr(j1)
           until False
         end;
        Dec(a2);
        if a2 < 0 then
         repeat
          case Index[j2] of
          0..$5f:
           begin
            a2 := a22;
            Incr(j2);
            if i = 0 then inc(Nt);
            break;
           end;
          $80,$90:
           begin
            a2 := a22;
            Incr(j2);
            break;
           end;
          $82..$8f:
           Inc(j2,2);
          $b1..$fe:
           a22 := Index[j2] - $b1;
          $91..$a0:
           b := Index[j2] - $91
          end;
          Incr(j2)
         until False;
        Dec(a3);
        if a3 < 0 then
         repeat
          case Index[j3] of
          0..$5f:
           begin
            a3 := a33;
            Incr(j3);
            if i = 0 then inc(Nt);
            break;
           end;
          $80,$90:
           begin
            a3 := a33;
            Incr(j3);
            break;
           end;
          $82..$8f:
           Inc(j3,2);
          $b1..$fe:
           a33 := Index[j3] - $b1;
          $91..$a0:
           b := Index[j3] - $91
          end;
          Incr(j3)
         until False;
        Inc(tm,b);
        Dec(DLCatcher);
        if DLCatcher < 0 then RaiseBadFileStructure
       until False
      end
    end
end;

procedure GetTimeFLS(Module:PModTypes;var Tm,Nt:integer);
var
 b:byte;
 a1,a11:shortint;
 i:integer;
 pptr:longword;
 j1:longword;
begin
   with Module^ do
    begin
     b := Index[FLS_PositionsPointer];
     a1 := 0; a11 := 0; i := 0;
     repeat
      pptr := i + FLS_PositionsPointer + 1;
      if pptr >= 65536 then RaiseBadFileStructure;
      if Index[pptr] = 0 then break;
      j1 := FLS_PatternsPointers[Index[pptr]].PatternA;
      repeat
       Dec(a1);
       if a1 < 0 then
        begin
         if Index[j1] = 255 then break;
         repeat
          case Index[j1] of
          0..$5f:
           begin
            if i = 0 then inc(Nt);
            Incr(j1);
            a1 := a11;
            break
           end;
          $80,$81:
           begin
            Incr(j1);
            a1 := a11;
            break
           end;
          $82..$8e:
           Inc(j1);
          $8f..$ff:
           a11 := Index[j1] - $a1
          end;
          Incr(j1);
         until False;
        end;
       Inc(tm,b);
      until False;
      Inc(i);
     until False;
     pptr := FLS_PositionsPointer + 1;
     if Index[pptr] = 0 then exit;
     j1 := FLS_PatternsPointers[Index[pptr]].PatternB;
     while Index[j1] <> 255 do
      repeat
       case Index[j1] of
       0..$5f:
        begin
         inc(Nt);
         Incr(j1);
         break
        end;
       $80,$81:
        begin
         Incr(j1);
         break
        end;
       $82..$8e:
        Inc(j1);
       end;
       Incr(j1);
      until False;

     j1 := FLS_PatternsPointers[Index[pptr]].PatternC;
     while Index[j1] <> 255 do
      repeat
       case Index[j1] of
       0..$5f:
        begin
         inc(Nt);
         Incr(j1);
         break
        end;
       $80,$81:
        begin
         Incr(j1);
         break
        end;
       $82..$8e:
        Inc(j1);
       end;
       Incr(j1);
      until False;

    end;
end;


var
 fout:TextFile;
 NOfFiles:integer;

procedure AnalizeFile(File_Name:string);



{function LoadTrackerModule(FType:Available_Types):boolean;
var
 f:file;
 i,i1,i2:integer;
 j,j2:longword;
 pwrd:WordPtr;
begin
Result := False;
  try
      AssignFile(f,File_Name);
      Reset(f,1);
      F_Length := FileSize(f);
      if F_Length > 65536 then F_Length := 65536;
   try
    FillChar(Module,65536,0);
    BlockRead(f,Module.Index[0],F_Length)
   finally
    CloseFile(f)
   end;
   case FType of
{   ASC0File:
    with Module do
     begin
      if MLen >= 65535 then exit;
      Move(ASC0_PatternsPointers,ASC1_PatternsPointers,MLen - 1);
      ASC1_LoopingPosition := 0;
      Inc(ASC1_PatternsPointers);
      Inc(ASC1_SamplesPointers);
      Inc(ASC1_OrnamentsPointers)
     end;}
   SQTFile:
    with Module do
     begin
      i := SQT_SamplesPointer - 10;
      if  i < 0 then exit;
      i1 := 0;
      i2 := SQT_PositionsPointer - i;
      if i2 < 0 then exit;
      while Index[i2] <> 0 do
       begin
        if i2 > 65536 - 8 then exit;
        if i1 < Index[i2] and $7f then
         i1 := Index[i2] and $7f;
        Inc(i2,2);
        if i1 < Index[i2] and $7f then
         i1 := Index[i2] and $7f;
        Inc(i2,2);
        if i1 < Index[i2] and $7f then
         i1 := Index[i2] and $7f;
        Inc(i2,3)
       end;
      j2 := longword(@Index[65535]);
      pwrd := @SQT_SamplesPointer;
      i1 := (SQT_PatternsPointer - i + i1 * 2) div 2;
      if i1 < 1 then exit;
      for i2 := 1 to i1 do
       begin
        if longword(pwrd) >= j2 then exit;
        if pwrd^ < i then exit;
        Dec(pwrd^,i);
        Inc(integer(pwrd),2)
       end
     end;
   FLSFile:
    begin
     i := Module.FLS_OrnamentsPointer - 16;
     if i >= 0 then
      with Module do
       repeat
        i2 := FLS_SamplesPointer + 2 - i;
        if (i2 >= 8) and (i2 < F_Length) then
         begin
          pwrd := @Index[i2];
          i1 := pwrd^ - i;
          if (i1 >= 8) and (i1 < F_Length) then
           begin
            pwrd := @Index[i2 - 4];
            i2 := pwrd^ - i;
            if (i2 >= 6) and (i2 < F_Length) then
             if i1 - i2 = $20 then
              begin
               i2 := FLS_PatternsPointers[1].PatternB - i;
               if (i2 > 21) and (i2 < F_Length) then
                begin
                 i1 := FLS_PatternsPointers[1].PatternA - i;
                 if (i1 > 20) and (i1 < F_Length) then
                  if Index[i1 - 1] = 0 then
                   begin
                    while (i1 < F_Length) and (Index[i1] <> 255) do
                     begin
                      repeat
                       case Index[i1] of
                       0..$5f,$80,$81:
                        begin
                         Inc(i1);
                         break
                        end;
                       $82..$8e:
                        Inc(i1)
                       end;
                       Inc(i1);
                      until i1 >= F_Length;
                     end;
                    if i1 + 1 = i2 then break
                   end
                end
              end
           end
         end;
        Dec(i)
       until i < 0;
     if i < 0 then
      exit
     else
      with Module do
       begin
        pwrd := @Module;
        i1 := FLS_SamplesPointer - i; if i1 and 1 <> 0 then exit;
        i2 := FLS_PositionsPointer - i; if (i2 - i1) and 3 <> 0 then exit;
        inc(i1,integer(pwrd));
        inc(i2,integer(pwrd) + 2);
        repeat
         Dec(pwrd^,i);
         Inc(integer(pwrd),2)
        until i1 <= integer(pwrd);
        Inc(integer(pwrd),2);
        repeat
         Dec(pwrd^,i);
         Inc(integer(pwrd),4)
        until i2 <= integer(pwrd)
       end
    end;
   GTRFile:
    with Module do
     begin
      pwrd := @GTR_SamplesPointers[0];
      if longword(pwrd) + (15 + 16 + 32 * 3) * 2 > longword(@Index[65536]) then
       exit;
      j := GTR_Address;
      for i := 0 to (15 + 16 + 32 * 3) - 1 do
       begin
        if pwrd^ < j then exit;
        Dec(pwrd^,j);
        Inc(integer(pwrd),2)
       end;
      GTR_Address := 0;
     end;
   end;
  except
   exit;
  end;
Result := True;
end;}
//function LoadTrackerModule(var Module:ModTypes;PPLItem:pointer;Index,MAddr,MLen:integer;Mem:pointer;FType:Available_Types):boolean;

var
 Module:ModTypes;
 F_Length:integer;


function LoadTrackerModule(FType:Available_Types):boolean;
var
 f:file;
 i,i1,i2:integer;
 j:longword;
 pwrd:PWord;
// Err:ErrorCodes;
begin
//Err := FileNoError;
 try
  try
{   if PPLItem <> nil then
    with PPlayListItem(PPLItem)^ do
     begin
      FType := FileType;
      MAddr := Address;}
      AssignFile(f,File_Name);
      Reset(f,1);
{      if FType = FXMFile then
       begin
        Seek(f,Offset + 6);
        Length := System.FileSize(f) - 6 - Offset;
       end
      else
       begin
        Seek(f,Offset);
        if Length = -1 then Length := System.FileSize(f);
       end;
     end;
   i := 0; if FType = FXMFile then i := MAddr;
   if PPLItem <> nil then
    with PPlayListItem(PPLItem)^ do
     begin
      if Length > 65536 - Int64(i) then Length := 65536 - Int64(i);
      MLen := Length
     end;}
     F_Length := FileSize(f);
     if F_Length > 65536 then F_Length := 65536;

   try
    FillChar(Module,65536,0);
//    if PPLItem <> nil then
     BlockRead(f,Module.Index[0],F_Length)
//    else
  //   Move(Mem^,Module.Index[i],MLen);
   finally
    {if PPLItem <> nil then }CloseFile(f);
   end;
   case FType of
{   PT3File:
    if ((PPLItem <> nil) and (LowerCase(ExtractFileExt(PPlaylistItem(PPLItem)^.FileName)) <> '.pt3')) or
       (PPLItem = nil) then
     begin
      i := 0; i1 := 0;
      with Module do
       begin
        while (i < 65535 - 201) and (PT3_PositionList[i] <> 255) do
         begin
          if longword(i1) < PT3_PositionList[i] then i1 := PT3_PositionList[i];
          Inc(i)
         end;
        if i >= 65535 - 201 then RaiseBadFileStructure;
        if i > 255 then
         PT3_NumberOfPositions := 255
        else
         PT3_NumberOfPositions := i;
        j := MAddr;
        if j <> 0 then
         begin
          if j >= 65536 then RaiseBadFileStructure;
          if PT3_PatternsPointer < j then RaiseBadFileStructure;
          Dec(PT3_PatternsPointer,j);
          for i := 0 to 31 do
           begin
            if PT3_SamplesPointers[i] < j then RaiseBadFileStructure;
            Dec(PT3_SamplesPointers[i],j)
           end;
          for i := 0 to 15 do
           begin
            if PT3_OrnamentsPointers[i] < j then RaiseBadFileStructure;
            Dec(PT3_OrnamentsPointers[i],j)
           end;
          pwrd := @Index[PT3_PatternsPointer];
          for i := 0 to i1 + 2 do
           begin
            if (PT3_PatternsPointer+i*2 >= 65535) or (pwrd^ < j) then RaiseBadFileStructure;
            Dec(pwrd^,j);
            inc(pwrd);
           end;
         end;
       end;
     end;
   PT2File:
    if ((PPLItem <> nil) and (LowerCase(ExtractFileExt(PPlaylistItem(PPLItem)^.FileName)) <> '.pt2')) or
       (PPLItem = nil) then
     begin
      i := 0; i1 := 0;
      with Module do
       begin
        while (i < 65535 - 131) and (PT2_PositionList[i] < 128) do
         begin
          if longword(i1) < PT2_PositionList[i] then i1 := PT2_PositionList[i];
          Inc(i)
         end;
        if i >= 65535 - 131 then RaiseBadFileStructure;
        if i > 255 then
         PT2_NumberOfPositions := 255
        else
         PT2_NumberOfPositions := i;
        j := MAddr;
        if j <> 0 then
         begin
          if j >= 65536 then RaiseBadFileStructure;
          for i := 0 to 31 do
           begin
            if PT2_SamplesPointers[i] < j then RaiseBadFileStructure;
            Dec(PT2_SamplesPointers[i],j)
           end;
          for i := 0 to 15 do
           begin
            if PT2_OrnamentsPointers[i] < j then RaiseBadFileStructure;
            Dec(PT2_OrnamentsPointers[i],j);
           end;
          pwrd := @Index[PT2_PatternsPointer];
          for i := 0 to i1 * 3 + 2 do
           begin
            if (PT2_PatternsPointer + i*2 >= 65535) or (pwrd^ < j) then RaiseBadFileStructure;
            Dec(pwrd^,j);
            Inc(pwrd);
           end;
         end;
       end;
     end;
   STPFile:
    if ((PPLItem <> nil) and (LowerCase(ExtractFileExt(PPlaylistItem(PPLItem)^.FileName)) <> '.stp')) or
       (PPLItem = nil) then
     with Module do
      if STP_Init_Id = 0 then
       begin
        j := MAddr; if j >= 65536 then RaiseBadFileStructure;
        i1 := (MLen - STP_PatternsPointer) div 2;
        if not (i1 in [0..255]) then RaiseBadFileStructure;
        STP_Init_Id := i1;
        pwrd := @Index[STP_PatternsPointer];
        for i := 0 to i1 - 1 do
         begin
          if (STP_PatternsPointer + i*2 >= 65535) or (pwrd^ < j) then RaiseBadFileStructure;
          Dec(pwrd^,j);
          Inc(pwrd);
         end;
       end;
   ASC0File:
    with Module do
     begin
      if MLen >= 65535 then RaiseBadFileStructure;
      Move(ASC0_PatternsPointers,ASC1_PatternsPointers,MLen - 1);
      ASC1_LoopingPosition := 0;
      Inc(ASC1_PatternsPointers);
      Inc(ASC1_SamplesPointers);
      Inc(ASC1_OrnamentsPointers)
     end;}
   SQTFile:
    with Module do
     begin
      i := SQT_SamplesPointer - 10;
      if  i < 0 then RaiseBadFileStructure;
      i1 := 0;
      i2 := SQT_PositionsPointer - i;
      if i2 < 0 then RaiseBadFileStructure;
      while Index[i2] <> 0 do
       begin
        if i2 > 65536 - 8 then RaiseBadFileStructure;
        if i1 < Index[i2] and $7f then
         i1 := Index[i2] and $7f;
        Inc(i2,2);
        if i1 < Index[i2] and $7f then
         i1 := Index[i2] and $7f;
        Inc(i2,2);
        if i1 < Index[i2] and $7f then
         i1 := Index[i2] and $7f;
        Inc(i2,3);
       end;
      pwrd := @SQT_SamplesPointer;
      i1 := (SQT_PatternsPointer - i + i1 * 2) div 2;
      if (i1 < 1) or (i1 >= (65536-2) div 2) then RaiseBadFileStructure;
      for i2 := 1 to i1 do
       begin
        if pwrd^ < i then RaiseBadFileStructure;
        Dec(pwrd^,i);
        Inc(pwrd);
       end;
     end;
{   FTCFile:
    begin
     if (((PPLItem <> nil) and (LowerCase(ExtractFileExt(PPlaylistItem(PPLItem)^.FileName)) <> '.ftc')) or
        (PPLItem = nil)) and (MAddr <> 0) then
      with Module do
       begin
        j := MAddr; if j >= 65536 then RaiseBadFileStructure;
        for i := 0 to 32 do
         begin
          if FTC_OrnamentsPointers[i] < j then RaiseBadFileStructure;
          Dec(FTC_OrnamentsPointers[i],j)
         end;
        for i := 0 to 31 do
         begin
          if FTC_SamplesPointers[i] < j then RaiseBadFileStructure;
          Dec(FTC_SamplesPointers[i],j)
         end;
        pwrd := @Index[FTC_PatternsPointer];
        i := $d4; i1 := 0;
        while (i < 65536) and (shortint(Index[i]) >= 0) do
         begin
          if i1 < Index[i] then i1 := Index[i];
          Inc(i,2);
         end;
        if i >= 65536 then RaiseBadFileStructure;
        i1 := (i1 + 1) * 3;
        if i1 < 1 then RaiseBadFileStructure;
        for i := 0 to i1-1 do
         begin
          if (FTC_PatternsPointer + i*2 >= 65535) or (pwrd^ < j) then RaiseBadFileStructure;
          Dec(pwrd^,j);
          Inc(pwrd);
         end;
       end;
    end;}
   FLSFile:
    begin
     i := Module.FLS_OrnamentsPointer - 16;
     if i >= 0 then
      with Module do
       repeat
        i2 := FLS_SamplesPointer + 2 - i;
        if (i2 >= 8) and (i2 < F_Length) then
         begin
          pwrd := @Index[i2];
          i1 := pwrd^ - i;
          if (i1 >= 8) and (i1 < F_Length) then
           begin
            pwrd := @Index[i2 - 4];
            i2 := pwrd^ - i;
            if (i2 >= 6) and (i2 < F_Length) then
             if i1 - i2 = $20 then
              begin
               i2 := FLS_PatternsPointers[1].PatternB - i;
               if (i2 > 21) and (i2 < F_Length) then
                begin
                 i1 := FLS_PatternsPointers[1].PatternA - i;
                 if (i1 > 20) and (i1 < F_Length) then
                  if Index[i1 - 1] = 0 then
                   begin
                    while (i1 < F_Length) and (Index[i1] <> 255) do
                     begin
                      repeat
                       case Index[i1] of
                       0..$5f,$80,$81:
                        begin
                         Inc(i1);
                         break
                        end;
                       $82..$8e:
                        Inc(i1)
                       end;
                       Inc(i1);
                      until i1 >= F_Length;
                     end;
                    if i1 + 1 = i2 then break;
                   end;
                end;
              end;
           end;
         end;
        Dec(i)
       until i < 0;
     if i < 0 then
//      Err := ErFLSAddrNotDetected
      exit
     else
      with Module do
       begin
        pwrd := @Module;
        i1 := FLS_SamplesPointer - i; if i1 and 1 <> 0 then RaiseBadFileStructure;
        i2 := FLS_PositionsPointer - i; if (i2 - i1) and 3 <> 0 then RaiseBadFileStructure;
        for j := 1 to i1 div 2 do
         begin
          Dec(pwrd^,i);
          Inc(pwrd);
         end;
        Inc(pwrd);
        for j := 1 to (i2 - i1) div 4 do
         begin
          Dec(pwrd^,i);
          Inc(pwrd,2);
         end;
       end;
    end;
   GTRFile:
    with Module do
     begin
      pwrd := @GTR_SamplesPointers[0];
      j := GTR_Address;
      for i := 0 to (15 + 16 + 32 * 3) - 1 do
       begin
        if pwrd^ < j then RaiseBadFileStructure;
        Dec(pwrd^,j);
        Inc(pwrd);
       end;
      GTR_Address := 0;
     end;
   end;
  except
{   on EFileStructureError do
    Err := ErBadFileStructure
   else
    Err := ErReadingFile;}
   exit;
  end;
 finally
//  Result := Err = FileNoError;
//  if PPLItem <> nil then PPlaylistItem(PPLItem)^.Error := Err;
//  if Index <> -1 then RedrawItem(Index);
 end;
Result := True;
end;

function CharCodes(const s:string):string;
var
 i:integer;
begin
Result := '';
for i := 1 to Length(s) do
 if s[i] in [#0..#31,#38,#127..#255] then
  Result := Result + '&#' + IntToStr(Ord(s[i])) + ';'
 else
  Result := Result + s[i];
end;

procedure Analize(FType:Available_Types);
var
 TimeLength,LoopPoint,NumOfNtIn1Pos,NumOfPositions,LoopPosition,i:integer;
 KsaId2:string;
 Song_Name,Song_Author,Song_NameC,Song_AuthorC,FTypeS:string;
 Wrd:word;
begin
if FType in [TrkFileMin..TrkFileMax] then
 if not LoadTrackerModule(FType) then
  begin
   Writeln('Loading error ('+File_Name+')');
   CloseFile(fout);
   halt;
  end;
TimeLength := 0; LoopPoint := 0; NumOfNtIn1Pos := 0;
try
case FType of
STCFile: GetTimeSTC(@Module,TimeLength,NumOfNtIn1Pos);
ASCFile: GetTimeASC(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
STPFile: GetTimeSTP(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
PSCFile: GetTimePSC(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
FLSFile: GetTimeFLS(@Module,TimeLength,NumOfNtIn1Pos);
FTCFile: GetTimeFTC(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
PT1File: GetTimePT1(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
PT2File: GetTimePT2(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
PT3File: GetTimePT3(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
SQTFile: GetTimeSQT(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
GTRFile: GetTimeGTR(@Module,TimeLength,LoopPoint,NumOfNtIn1Pos);
end;
except
 Writeln('Time calculation error ('+File_Name+')');
 CloseFile(fout);
 halt;
end;
if TimeLength = 0 then
 begin
  Writeln('Time calculation error (=0) ('+File_Name+')');
  CloseFile(fout);
  halt;
 end;

Song_Name := ''; Song_Author := '';
  case FType of
  STCFile:  begin
             SetLength(KsaId2,20);
             Move(Module.ST_Name,KsaId2[1],20);
             Song_Name := Copy(KsaId2,1,18);
             if (Song_Name='SONG BY ST COMPILE') or
                (Song_Name='SONG BY MB COMPILE') or
                (Song_Name='SONG BY ST-COMPILE') or
                (Song_Name='SOUND TRACKER v1.1') or
                (Song_Name='S.T.FULL EDITION  ') or
                (Song_Name='SOUND TRACKER v1.3') then
              Song_Name := ''
             else
              begin
               Wrd := PWord(@KsaId2[19])^;
               if Wrd <> F_Length then
                if KsaId2[19] in [' '..#127] then
                 begin
                  Song_Name := Song_Name + KsaId2[19];
                  if KsaId2[20] in [' '..#127] then
                   Song_Name := Song_Name + KsaId2[20];
                 end;
              end
            end;
  GTRFIle:  begin
             SetLength(Song_Name,32);
             Move(Module.GTR_Name,Song_Name[1],32);
            end;
  PSCFile:  begin
             SetLength(Song_Name,20);
             SetLength(Song_Author,20);
             Move(Module.PSC_MusicName[$19],Song_Name[1],20);
             Move(Module.PSC_MusicName[$31],Song_Author[1],20);
            end;
  FTCFile:  begin
             SetLength(Song_Name,42);
             Move(Module.FTC_MusicName[8],Song_Name[1],42)
            end;
  PT1File:  begin
             SetLength(Song_Name,30);
             Move(Module.PT1_MusicName,Song_Name[1],30)
            end;
  PT2File:  begin
             SetLength(Song_Name,30);
             Move(Module.PT2_MusicName,Song_Name[1],30)
            end;
  PT3File:  begin
             SetLength(Song_Name,32);
             SetLength(Song_Author,32);
             Move(Module.PT3_MusicName[$1E],Song_Name[1],32);
             Move(Module.PT3_MusicName[$42],Song_Author[1],32);
            end;
  ASCFile:  begin
             if Module.ASC1_PatternsPointers -
                          Module.ASC1_Number_Of_Positions = 72 then
              begin
               SetLength(Song_Name,20);
               SetLength(Song_Author,20);
               Move(Module.Index[Module.ASC1_PatternsPointers - 44],
                        Song_Name[1],20);
               Move(Module.Index[Module.ASC1_PatternsPointers - 20],
                        Song_Author[1],20);
              end
            end;
  STPFile:  begin
             SetLength(KsaId2,28);
             Move(Module.Index[10],KsaId2[1],28);
             if KsaId2 = KsaId then
              begin
               SetLength(Song_Name,25);
               Move(Module.Index[38],Song_Name[1],25)
              end
            end;
  end;

Song_NameC := Song_Name;
Song_AuthorC := Song_Author;

for i := 1 to Length(Song_Name) do
 if Song_NameC[i] in [#0..#31,#127] then
  Song_NameC[i] := '_';

for i := 1 to Length(Song_Author) do
 if Song_AuthorC[i] in [#0..#31,#127] then
  Song_AuthorC[i] := '_';

//ISO-8859-1 converts any code in [0..255] to/from unicode without lossies
SetCodePage(RawByteString(Song_NameC),CodePageNameToCodePage('ISO-8859-1'),False);
SetCodePage(RawByteString(Song_AuthorC),CodePageNameToCodePage('ISO-8859-1'),False);

NumOfPositions := 0; LoopPosition := 0; FTypeS := '';
case FType of
STCFile:
 begin
  NumOfPositions := Module.Index[Module.ST_PositionsPointer] + 1;
  FTypeS := 'STC';
 end;
ASCFile:
 begin
  LoopPosition := Module.ASC1_LoopingPosition;
  NumOfPositions := Module.ASC1_Number_Of_Positions;
  FTypeS := 'ASC';
 end;
STPFile:
 begin
  LoopPosition := Module.Index[Module.STP_PositionsPointer + 1];
  NumOfPositions := Module.Index[Module.STP_PositionsPointer];
  FTypeS := 'STP';
 end;
PSCFile:
 begin
  i := Module.PSC_PatternsPointer;
  while Module.Index[i + 1] <> 255 do inc(i,8);
  LoopPosition := (PWord(@Module.Index[i + 2])^ - Module.PSC_PatternsPointer) div 8;
  NumOfPositions := (i - Module.PSC_PatternsPointer) div 8;
  FTypeS := 'PSC';
 end;
FLSFile:
 begin
  i := Module.FLS_PositionsPointer + 1;
  while Module.Index[i] <> 0 do inc(i);
  NumOfPositions := i - Module.FLS_PositionsPointer - 1;
  FTypeS := 'FLS';
 end;
FTCFile:
 begin
  LoopPosition := Module.FTC_Loop_Position;
  i := 0; while Module.FTC_Positions[i].Pattern <> 255 do inc(i);
  NumOfPositions := i;
  FTypeS := 'FTC';
 end;
PT1File:
 begin
  LoopPosition := Module.PT1_LoopPosition;
  NumOfPositions := Module.PT1_NumberOfPositions;
  FTypeS := 'PT1';
 end;
PT2File:
 begin
  LoopPosition := Module.PT2_LoopPosition;
  NumOfPositions := Module.PT2_NumberOfPositions;
  FTypeS := 'PT2';
 end;
PT3File:
 begin
  LoopPosition := Module.PT3_LoopPosition;
  NumOfPositions := Module.PT3_NumberOfPositions;
  FTypeS := 'PT3';
 end;
SQTFile:
 begin
  i := Module.SQT_PositionsPointer;
  while (Module.Index[i] <> 0) and (Module.Index[i + 2] <> 0) and
        (Module.Index[i + 4] <> 0) do inc(i,7);
  LoopPosition := (Module.SQT_LoopPointer - Module.SQT_PositionsPointer) div 7;
  NumOfPositions := (i - Module.SQT_PositionsPointer) div 7;
  FTypeS := 'SQT';
 end;
GTRFile:
 begin
  LoopPosition := Module.GTR_LoopPosition;
  NumOfPositions := Module.GTR_NumberOfPositions;
  FTypeS := 'GTR';
 end;
end;

Writeln(fout,File_Name,#9,FTypeS,#9,IntToStr(TimeLength),#9,IntToStr(LoopPoint),
  #9,NumOfPositions,#9,LoopPosition,#9,IntToStr(NumOfNtIn1Pos),#9,
  Song_NameC,#9,Song_AuthorC,#9,CharCodes(Song_Name),#9,CharCodes(Song_Author));

end;


var
 SFileExt:string;
begin
if not FileExists(File_Name) then exit;
Inc(NOfFiles);
SFileExt := LowerCase(ExtractFileExt(File_Name));
if SFileExt = '.stc' then Analize(STCFile) else
if SFileExt = '.asc' then Analize(ASCFile) else
if SFileExt = '.stp' then Analize(STPFile) else
if SFileExt = '.psc' then Analize(PSCFile) else
if SFileExt = '.fls' then Analize(FLSFile) else
if SFileExt = '.ftc' then Analize(FTCFile) else
if SFileExt = '.pt1' then Analize(PT1File) else
if SFileExt = '.pt2' then Analize(PT2File) else
if SFileExt = '.pt3' then Analize(PT3File) else
if SFileExt = '.sqt' then Analize(SQTFile) else
if SFileExt = '.gtr' then Analize(GTRFile) else
{if SFileExt = '.fxm' then Analize(FXMFile) else
if SFileExt = '.psm' then Analize(PSMFile) else
if SFileExt = '.vtx' then Analize(VTXFile) else
if SFileExt = '.ym' then Analize(YM3File) else
if SFileExt = '.ay' then OpenAYFile else
if SFileExt = '.aym' then OpenAYMFile else}
exit;
end;

var
 Recurse:boolean;
 FNStr:string;

procedure CheckPath(Dir:string);
var
 SearchRec:TSearchRec;
 i:integer;
begin
Dir := IncludeTrailingBackslash(Dir);
i := FindFirst(Dir + FNStr,faAnyFile,SearchRec);
try
while i = 0 {<> ERROR_NO_MORE_FILES} do
 begin
  if i = 0 then
   if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
    if SearchRec.Attr and faDirectory <> 0 then
     begin
      if Recurse then
       CheckPath(Dir + SearchRec.Name)
     end
    else if SearchRec.Size > 0 then
     AnalizeFile(Dir + SearchRec.Name);
  i := FindNext(SearchRec);
 end;
finally
FindClose(SearchRec);
end;
end;

procedure ExitUsage;
 begin
  Writeln('  Usage:');
  Writeln(' tran [/r] [foldername]');
  Writeln('  or');
  Writeln(' tran [/r] [filename]');
  Writeln;
  Writeln('/r - recurse subfolders');
  Writeln('Wildcards are allowed in names.');
  Halt(1)
 end;

var
 ParStr:string;
 err:integer;

begin
Writeln('Tr_Songs Modules Analizer v2');
Writeln('(c)2006,2016 S.V.Bulba E-Mail: svbulba@gmail.com');
Writeln('Support page: http://bulba.untergrund.net/');
Writeln;
Recurse := False;
//ParStr := 'Error!!!-Sinclair town 2 serial_0.stc';
case ParamCount of
1:ParStr := ParamStr(1);
2:
 begin
  if LowerCase(ParamStr(1)) <> '/r' then ExitUsage;
  Recurse := True;
  ParStr := ParamStr(2);
 end
else
 ExitUsage;
end;

AssignFile(fout,'Tr_Songs_Analizing.txt');
Rewrite(fout);
Writeln(fout,#$EF#$BB#$BF'FileName'#9'FileType'#9'TimeLength'#9'LoopPoint'#9'NumOfPositions'#9'LoopPosition'#9'NumOfNotesIn1Pos'#9'SongName_ISO-8859-1'#9'Song_Author_ISO-8859-1'#9'SongName_CharCodes'#9'Song_Author_CharCodes');
FileMode := 0;
{err := GetFileAttributes(PChar(ParStr));
if (err <> -1) and (err and FILE_ATTRIBUTE_DIRECTORY <> 0) then}
if DirectoryExists(ParStr) then
 FNStr := '*'
else
 begin
  FNStr := ExtractFileName(ParStr);
  ParStr := ExtractFilePath(ParStr);
  if ParStr = '' then
   ParStr := ExtractFilePath(ParamStr(0));
 end;
NOfFiles := 0;
CheckPath(ParStr);
if NOfFiles = 0 then Writeln('No files are found');
CloseFile(fout);
end.
